{ decls.h declarations for sim552 }

type
    sfrmodel = record
       name : string[5];
       addr : byte;
       rdwr : boolean;
    end;

    regmodel = record
       name : string[5];
       addr : byte;
    end;

    portmodel = record
       name : string[5];
       addr : byte;
    end;

    AddressingMode = (none, addr11, addr16, dir7, dir10, data8, data16, rel,
        rel10, bit7, bit10, bitrel, dirdata, predir, dirdir, datarel, dirrel,
        dirrel7, crel );

    Instructions = record
       name   : string[19];
       nbytes : integer;
       adrmode: addressingmode;
       cycles : integer;
    end;

    FileType = (Intel, Motorola);

    FileInfo = Record
      FName   : PLabel;
      Name    : PInputLine;
      FStart  : PLabel;
      StartAdr: PInputLine;
      FEnd    : PLabel;
      EndAdr  : PInputLine;
      FType   : PRadioButtons;
    end;

    FillMem = Record
      FMStart  : PLabel;
      StartAdr : PInputLine;
      FMEnd    : PLabel;
      EndAdr   : PInputLine;
      FMValue  : PLabel;
      FillByte : PInputLine;
    end;

const
     VersionNo = '1.2 (July93)';
     xramlimit      = $3fff;
     cramlimit      = $3fff;
     FILEUP         = 0;
     FILEDN         = 1;
     cmDownLoad     = 101;
     cmUpLoad       = 102;
     cmRegisters    = 103;
     cmXdata        = 104;
     cmToggle       = 105;
     cmIdata        = 106;
     cmAssembly     = 107;
     cmSFR          = 108;
     cmPorts        = 109;
     cmClearMem     = 110;
     cmFillMem      = 111;
     cmClearCyl     = 112;
     cmHaltPC       = 113;
     cmRunPC        = 114;
     cmCode         = 115;
     cmChDir        = 117;
     cmGoPCAdr      = 119;
     cmReset        = 120;
     cmTracePC      = 121;
     cmUpdate       = 123;

     wincount  : integer = 0;

     R0 = 0;
     R1 = 1;
     R2 = 2;
     R3 = 3;
     R4 = 4;
     R5 = 5;
     R6 = 6;
     R7 = 7;
     { addresses of SFR registers follow }
     P0   = $80;
     SP   = $81;
     DPL  = $82;
     DPH  = $83;
     PCON = $87;
     TCON = $88;
     TMOD = $89;
     TL0  = $8A;
     TL1  = $8B;
     TH0  = $8C;
     TH1  = $8D;
     P1   = $90;
     S0CON= $98;
     S0BUF= $99;
     P2   = $A0;
     IEN0 = $A8;
     CML0 = $A9;
     CML1 = $AA;
     CML2 = $AB;
     CTL0 = $AC;
     CTL1 = $AD;
     CTL2 = $AE;
     CTL3 = $AF;
     P3   = $B0;
     IP0  = $B8;
     P4   = $C0;
     P5   = $C4;
     ADCON= $C5;
     ADCH = $C6;
     TM2IR= $C8;
     CMH0 = $C9;
     CMH1 = $CA;
     CMH2 = $CB;
     CTH0 = $CC;
     CTH1 = $CD;
     CTH2 = $CE;
     CTH3 = $CF;
     PSW  = $D0;
     S1CON= $D8;
     S1STA= $D9;
     S1DAT= $DA;
     S1ADR= $DB;
     ACC  = $E0;
     IEN1 = $E8;
     TM2CON=$EA;
     CTCON= $EB;
     TML2 = $EC;
     TMH2 = $ED;
     STE  = $EE;
     RTE  = $EF;
     B    = $F0;
     IP1  = $F8;
     PWM0 = $FC;
     PWM1 = $FD;
     PWMP = $FE;
     T3   = $FF;

     Reg       : array[0..6]   of regmodel = (
          (name : 'Acc  '; addr : ACC ),
          (name : 'B    '; addr : B   ),
          (name : 'PSW  '; addr : PSW ),
          (name : 'SP   '; addr : SP  ),
          (name : 'PC   '; addr : $00 ),
          (name : 'DPTR '; addr : $00 ),
          (name : 'Clock'; addr : $00 ) );
     Sfr       : array[0..55]  of sfrmodel = (
          (name : 'P0   '; addr : P0;   rdwr : true ),
          (name : 'SP   '; addr : SP;   rdwr : true ),
          (name : 'DPL  '; addr : DPL;  rdwr : true ),
          (name : 'DPH  '; addr : DPH;  rdwr : true ),
          (name : 'PCON '; addr : PCON; rdwr : true ),
          (name : 'TCON '; addr : TCON; rdwr : true ),
          (name : 'TMOD '; addr : TMOD; rdwr : true ),
          (name : 'TL0  '; addr : TL0;  rdwr : true ),
          (name : 'TL1  '; addr : TL1;  rdwr : true ),
          (name : 'TH0  '; addr : TH0;  rdwr : true ),
          (name : 'TH1  '; addr : TH1;  rdwr : true ),
          (name : 'P1   '; addr : P1;   rdwr : true ),
          (name : 'S0CON'; addr : S0CON;rdwr : true ),
          (name : 'S0BUF'; addr : S0BUF;rdwr : true ),
          (name : 'P2   '; addr : P2;   rdwr : true ),
          (name : 'IEN0 '; addr : IEN0; rdwr : true ),
          (name : 'CML0 '; addr : CML0; rdwr : true ),
          (name : 'CML1 '; addr : CML1; rdwr : true ),
          (name : 'CML2 '; addr : CML2; rdwr : true ),
          (name : 'CTL0 '; addr : CTL0; rdwr : false),
          (name : 'CTL1 '; addr : CTL1; rdwr : false),
          (name : 'CTL2 '; addr : CTL2; rdwr : false),
          (name : 'CTL3 '; addr : CTL3; rdwr : false),
          (name : 'P3   '; addr : P3;   rdwr : true ),
          (name : 'IP0  '; addr : IP0;  rdwr : true ),
          (name : 'P4   '; addr : P4;   rdwr : true ),
          (name : 'P5   '; addr : P5;   rdwr : false),
          (name : 'ADCON'; addr : ADCON; rdwr: true ),
          (name : 'ADCH '; addr : ADCH;  rdwr: false),
          (name : 'TM2IR'; addr : TM2IR; rdwr: true ),
          (name : 'CMH0 '; addr : CMH0; rdwr : true ),
          (name : 'CMH1 '; addr : CMH1; rdwr : true ),
          (name : 'CMH2 '; addr : CMH2; rdwr : true ),
          (name : 'CTH0 '; addr : CTH0; rdwr : false),
          (name : 'CTH1 '; addr : CTH1; rdwr : false),
          (name : 'CTH2 '; addr : CTH2; rdwr : false),
          (name : 'CTH3 '; addr : CTH3; rdwr : false),
          (name : 'PSW  '; addr : PSW;  rdwr : true ),
          (name : 'S1CON'; addr : S1CON; rdwr: true ),
          (name : 'S1STA'; addr : S1STA; rdwr: false),
          (name : 'S1DAT'; addr : S1DAT; rdwr: true ),
          (name : 'S1ADR'; addr : S1ADR; rdwr: true ),
          (name : 'ACC  '; addr : ACC;  rdwr : true ),
          (name : 'IEN1 '; addr : IEN1; rdwr : true ),
          (name : 'TM2CO'; addr : TM2CON;rdwr: true ),
          (name : 'CTCON'; addr : CTCON;rdwr : true ),
          (name : 'TML2 '; addr : TML2; rdwr : false),
          (name : 'TMH2 '; addr : TMH2; rdwr : false),
          (name : 'STE  '; addr : STE;  rdwr : true ),
          (name : 'RTE  '; addr : RTE;  rdwr : true ),
          (name : 'B    '; addr : B;    rdwr : true ),
          (name : 'IP1  '; addr : IP1;  rdwr : true ),
          (name : 'PWM0 '; addr : PWM0; rdwr : true ),
          (name : 'PWM1 '; addr : PWM1; rdwr : true ),
          (name : 'PWMP '; addr : PWMP; rdwr : true ),
          (name : 'T3   '; addr : T3;   rdwr : true ) );

     Port552   : array[0..5]   of portmodel = (
          (name : 'P0  '; addr : P0 ),
          (name : 'P1  '; addr : P1 ),
          (name : 'P2  '; addr : P2 ),
          (name : 'P3  '; addr : P3 ),
          (name : 'P4  '; addr : P4 ),
          (name : 'P5  '; addr : P5 ));

     hexdigits : array[0..15] of char = ( '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F' );

     binvalues : array[0..15] of string[4] = (
          ( '0000' ), ( '0001' ), ( '0010' ), ( '0011' ),
          ( '0100' ), ( '0101' ), ( '0110' ), ( '0111' ),
          ( '1000' ), ( '1001' ), ( '1010' ), ( '1011' ),
          ( '1100' ), ( '1101' ), ( '1110' ), ( '1111' ));

Instrs : Array[0..$FF] of Instructions = (
(name : 'NOP              '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'AJMP  XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'LJMP  XXXX       '; nbytes : 3; adrmode : addr16; cycles : 2 ),
(name : 'RR    A          '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   A          '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   XX         '; nbytes : 2; adrmode : dir7  ; cycles : 1 ),
(name : 'INC   @R0        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   @R1        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R0         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R1         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R2         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R3         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R4         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R5         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R6         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'INC   R7         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{10-1f}
(name : 'JBC   XX, XXXX   '; nbytes : 3; adrmode : bitrel; cycles : 2 ),
(name : 'ACALL XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'LCALL XXXX       '; nbytes : 3; adrmode : addr16; cycles : 2 ),
(name : 'RRC   A          '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   A          '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   XX         '; nbytes : 2; adrmode : dir7  ; cycles : 1 ),
(name : 'DEC   @R0        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   @R1        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R0         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R1         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R2         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R3         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R4         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R5         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R6         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DEC   R7         '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{20-2f}
(name : 'JB    XX, XXXX   '; nbytes : 3; adrmode : bitrel; cycles : 2 ),
(name : 'AJMP  XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'RET              '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'RL    A          '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'ADD   A, XX      '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'ADD   A, @R0     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, @R1     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R0      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R1      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R2      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R3      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R4      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R5      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R6      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADD   A, R7      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{30-3f}
(name : 'JNB   XX, XXXX   '; nbytes : 3; adrmode : bitrel; cycles : 2 ),
(name : 'ACALL XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'RETI             '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'RLC   A          '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'ADDC  A, XX      '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'ADDC  A, @R0     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, @R1     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R0      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R1      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R2      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R3      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R4      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R5      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R6      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ADDC  A, R7      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{40-4f}
(name : 'JC    XXXX       '; nbytes : 2; adrmode : rel   ; cycles : 2 ),
(name : 'AJMP  XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'ORL   XX, A      '; nbytes : 2; adrmode : predir; cycles : 1 ),
(name : 'ORL   XX,#XX     '; nbytes : 3; adrmode : dirdata; cycles : 2),
(name : 'ORL   A,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'ORL   A, XX      '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'ORL   A, @R0     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, @R1     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R0      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R1      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R2      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R3      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R4      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R5      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R6      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ORL   A, R7      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{50-5f}
(name : 'JNC   XXXX       '; nbytes : 2; adrmode : rel   ; cycles : 2 ),
(name : 'ACALL XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'ANL   XX, A      '; nbytes : 2; adrmode : predir; cycles : 1 ),
(name : 'ANL   XX,#XX     '; nbytes : 3; adrmode : dirdata;cycles : 2 ),
(name : 'ANL   A,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'ANL   A, XX      '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'ANL   A, @R0     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, @R1     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R0      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R1      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R2      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R3      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R4      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R5      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R6      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'ANL   A, R7      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{60-6f}
(name : 'JZ    XXXX       '; nbytes : 2; adrmode : rel   ; cycles : 2 ),
(name : 'AJMP  XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'XRL   XX, A      '; nbytes : 2; adrmode : predir; cycles : 1 ),
(name : 'XRL   XX,#XX     '; nbytes : 3; adrmode : dirdata; cycles : 2),
(name : 'XRL   A,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'XRL   A, XX      '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'XRL   A, @R0     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, @R1     '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R0      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R1      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R2      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R3      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R4      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R5      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R6      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XRL   A, R7      '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{70-7f}
(name : 'JNZ   XXXX       '; nbytes : 2; adrmode : rel   ; cycles : 2 ),
(name : 'ACALL XXXX       '; nbytes : 2; adrmode : addr11; cycles : 2),
(name : 'ORL   C, XX      '; nbytes : 2; adrmode : bit10 ; cycles : 2 ),
(name : 'JMP   @A+DPTR    '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'MOV   A,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV   XX,#XX     '; nbytes : 3; adrmode : dirdata; cycles : 2),
(name : 'MOV @R0,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV @R1,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R0,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R1,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R2,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R3,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R4,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R5,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R6,#XX      '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'MOV  R7,#XX        '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
{80-8f}
(name : 'SJMP  XXXX         '; nbytes : 2; adrmode : rel   ; cycles : 2 ),
(name : 'AJMP  XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'ANL   C, XX        '; nbytes : 2; adrmode : bit10 ; cycles : 2 ),
(name : 'MOVC  A,@A+PC(XXXX)'; nbytes : 1; adrmode : crel  ; cycles : 2 ),
(name : 'DIV   AB           '; nbytes : 1; adrmode : none  ; cycles : 4 ),
(name : 'MOV   XX, XX       '; nbytes : 3; adrmode : dirdir; cycles : 2 ),
(name : 'MOV   XX, @R0      '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, @R1      '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R0       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R1       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R2       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R3       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R4       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R5       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R6       '; nbytes : 2; adrmode : predir; cycles : 2 ),
(name : 'MOV   XX, R7       '; nbytes : 2; adrmode : predir; cycles : 2 ),
{90-9f}
(name : 'MOV DPTR,#XXXX     '; nbytes : 3; adrmode : data16; cycles : 2 ),
(name : 'ACALL XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'MOV   XX, C        '; nbytes : 2; adrmode : bit7  ; cycles : 2 ),
(name : 'MOVC  A,@A+DPTR    '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'SUBB  A,#XX        '; nbytes : 2; adrmode : data8 ; cycles : 1 ),
(name : 'SUBB  A, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'SUBB  A, @R0       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, @R1       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R0        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R1        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R2        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R3        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R4        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R5        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R6        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SUBB  A, R7        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{a0-af}
(name : 'ORL   C,/XX        '; nbytes : 2; adrmode : bit10 ; cycles : 2 ),
(name : 'AJMP  XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'MOV   C, XX        '; nbytes : 2; adrmode : bit10 ; cycles : 1 ),
(name : 'INC   DPTR         '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'MUL   AB           '; nbytes : 1; adrmode : none  ; cycles : 4 ),
(name : '                   '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV  @R0,XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  @R1,XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R0, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R1, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R2, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R3, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R4, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R5, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R6, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
(name : 'MOV  R7, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 2 ),
{b0-bf}
(name : 'ANL   C,/XX        '; nbytes : 2; adrmode : bit10 ; cycles : 2 ),
(name : 'ACALL XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'CPL   XX           '; nbytes : 2; adrmode : bit7  ; cycles : 1 ),
(name : 'CPL   C            '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'CJNE  A, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE  A,  XX,XXXX  '; nbytes : 3; adrmode : dirrel; cycles : 2 ),
(name : 'CJNE @R0,#XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE @R1,#XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R0, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R1, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R2, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R3, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R4, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R5, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R6, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
(name : 'CJNE R7, #XX,XXXX  '; nbytes : 3; adrmode : datarel; cycles : 2),
{c0-cf}
(name : 'PUSH  XX           '; nbytes : 2; adrmode : dir7  ; cycles : 2 ),
(name : 'AJMP  XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'CLR   XX           '; nbytes : 2; adrmode : bit7  ; cycles : 1 ),
(name : 'CLR   C            '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'SWAP  A            '; nbytes : 2; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'XCH   A, @R0       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, @R1       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R0        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R1        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R2        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R3        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R4        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R5        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R6        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCH   A, R7        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{d0-df}
(name : 'POP   XX           '; nbytes : 2; adrmode : dir7  ; cycles : 2 ),
(name : 'ACALL XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'SETB  XX           '; nbytes : 2; adrmode : bit7  ; cycles : 1 ),
(name : 'SETB  C            '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DA    A            '; nbytes : 2; adrmode : none  ; cycles : 1 ),
(name : 'DJNZ  XX,XXXX      '; nbytes : 3; adrmode : dirrel7; cycles : 2),
(name : 'XCHD  A, @R0       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'XCHD  A, @R1       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'DJNZ  R0,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R1,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R2,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R3,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R4,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R5,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R6,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
(name : 'DJNZ  R7,XXXX      '; nbytes : 2; adrmode : rel10 ; cycles : 2 ),
{e0-ef}
(name : 'MOVX  A, @DPTR     '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'AJMP  XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'MOVX  A, @R0       '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'MOVX  A, @R1       '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'CLR   A            '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, XX        '; nbytes : 2; adrmode : dir10 ; cycles : 1 ),
(name : 'MOV   A, @R0       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, @R1       '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R0        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R1        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R2        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R3        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R4        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R5        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R6        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   A, R7        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
{f0-ff}
(name : 'MOVX  @DPTR, A     '; nbytes : 2; adrmode : none  ; cycles : 2 ),
(name : 'ACALL XXXX         '; nbytes : 2; adrmode : addr11; cycles : 2 ),
(name : 'MOVX  @R0, A       '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'MOVX  @R1, A       '; nbytes : 1; adrmode : none  ; cycles : 2 ),
(name : 'CPL   A            '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   XX, A        '; nbytes : 2; adrmode : predir; cycles : 1 ),
(name : 'MOV  @R0, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV  @R1, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R0, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R1, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R2, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R3, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R4, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R5, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R6, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ),
(name : 'MOV   R7, A        '; nbytes : 1; adrmode : none  ; cycles : 1 ));
