
unit fileio;

interface
uses objects, drivers, views, menus, app, dialogs, dos, crt,
     msgbox, stddlg, strutils, globals;

{$I decls.h}

function calcmotorolachksum( line : string ) : string;
function calcintelchksum( line : string ) : string;
function FileExists(FileName: string) : Boolean;
procedure writeintelrecord( var txtfile : text; rectype : string; addr : word; data : string );
procedure writemotorolarecord( var txtfile : text; rectype : string; addr : word; data : string );
function InvalidIntelLine(line:string) : Boolean;
function InvalidMotorolaLine(line:string) : Boolean;

IMPLEMENTATION
var num, total, loop : integer;
    temp : string;
    checksum : string;
    line     : string;
    loadadr  : string;
    reclen   : string;
    datastr    : string;
    mychksum   : string;
    filechksum : string;

function calcmotorolachksum( line : string ) : string;
begin
    loop  := 1;
    total := 0;
    while loop < length(line) do begin
       temp  := line[loop] + line[loop+1];
       total := total + strtointeger( temp );
       loop := loop + 2;
    end;
    total := 255 - (total AND $00ff);
    calcmotorolachksum := integertostring(total);
end;

function calcintelchksum( line : string ) : string;
begin
    loop  := 1;
    total := 0;
    while loop < length(line) do begin
       temp  := line[loop] + line[loop+1];
       total := total + strtointeger( temp );
       loop := loop + 2;
    end;
    total := 256 - (total MOD 256);
    calcintelchksum := integertostring(total);
end;

function FileExists(FileName: string) : Boolean;
{ Returns True if file exists; otherwise, it returns False.
  Closes the file if it exists. }
var  f: file;
begin
  {$I-}
  Assign(f, FileName);
  Reset(f);
  Close(f);
  {$I+}
  FileExists := (IOResult = 0) and
   (FileName <> '');
end;  { FileExists }

{ 552 >> file }
procedure writeintelrecord( var txtfile : text; rectype : string; addr : word; data : string );
begin
     line := '';
     loadadr := wordtostring(addr);
     reclen  := integertostring(length(data) DIV 2);
     line    := reclen + loadadr + rectype + data;
     checksum:= calcintelchksum( line );
     writeln(txtfile, ':'+line+checksum);
end;

{ 552 >> file }
procedure writemotorolarecord( var txtfile : text; rectype : string; addr : word; data : string );
begin
     {s1,msb/lsb-of-datalen, loadadr(4msbfirst), databytes}
     line := '';
     loadadr := wordtostring(addr);
     reclen  := integertostring((length(data) DIV 2) + 3);
     line    := reclen + loadadr + data;
     checksum:= calcmotorolachksum( line );
     writeln(txtfile, rectype + line+checksum);
end;

function InvalidIntelLine(line:string) : Boolean;
var total, loop:integer;
    datastr    : string;
    mychksum   : string;
    filechksum : string;
begin
    total := length(line);
    filechksum := line[total-1]+line[total];
    datastr := '';
    for loop := 2 to total - 2 do            {get past :}
        datastr := datastr + line[loop];
    mychksum := calcintelchksum(datastr);
    if mychksum <> filechksum then
       InvalidIntelLine := True
    else InvalidIntelLine := False
end;

function InvalidMotorolaLine(line:string) : Boolean;
begin
    total := length(line);
    filechksum := line[total-1]+line[total];
    datastr := '';
    for loop := 3 to total - 2 do           {get past s1}
        datastr := datastr + line[loop];
    mychksum := calcmotorolachksum(datastr);
    if mychksum <> filechksum then
       InvalidMotorolaLine := True
    else InvalidMotorolaLine := False
end;

begin
end.
