{ 552 simulator program }

program sim552;
{$X+}        {allow functons to be treated as procedures, discard results    }
{$S+}        {check stack overflow at beginning of each function             }

uses objects, drivers, views, menus, app, dialogs, dos, crt,
     msgbox, stddlg, strutils, fileio, globals, engine;

type
    viewmodel = ( regs, programdata, externdata, interndata,
                  assembly, specialfunctregs, ports, pwmo );

    mon = object(Tapplication)
        constructor Init;
        procedure   InitMenuBar; virtual;
        procedure   InitStatusLine; virtual;
        procedure   HandleEvent( var Event: TEvent ); virtual;
        procedure   OutOfMemory; virtual;
        procedure   ChangeDir;
        destructor  Done; virtual;
    end;

    scrtype = ^scrolltype;
    scrolltype = object(tlistviewer)
      scroller : viewmodel;
      constructor init( var r:trect; anumcols:integer; ahscrollbar, avscrollbar:pscrollbar;
                  scrollertype : viewmodel );
      function    gettext( item:integer; maxlen:integer) : string; virtual;
      function    getpalette : Ppalette; virtual;
      procedure   HandleEvent( var Event: TEvent ); virtual;
    end;
    scrwindow = ^scrollwindow;
    scrollwindow = object(twindow)
      vscrollbar : pscrollbar;
      interior   : scrtype;
      constructor init( var r:trect; wintitle:string; winnum : word;
                  scrollertype : viewmodel );
    end;

{$I decls.h}

var
   monitor    : mon;
   pmonitor   : ^mon;
   R          : trect;
   pdat, idat, cdat, xdat, rdat, asmdat, sfrdat, pwmdat : trect;
   pwin, iwin, cwin, xwin, rwin, asmwin, sfrwin, pwmwin : scrwindow;

procedure UpdateWindows;
begin
     {broadcast event for all windows to update themselves}
     Message( rwin,   evBroadcast, cmScrollBarChanged, nil );
     Message( cwin,   evBroadcast, cmScrollBarChanged, nil );
     Message( xwin,   evBroadcast, cmScrollBarChanged, nil );
     Message( pwin,   evBroadcast, cmScrollBarChanged, nil );
     Message( pwmwin, evBroadcast, cmScrollBarChanged, nil );
     Message( iwin,   evBroadcast, cmScrollBarChanged, nil );
     Message( sfrwin, evBroadcast, cmScrollBarChanged, nil );
     Message( asmwin, evBroadcast, cmScrollBarChanged, nil );
end;

{file >> 552}
function ProcessIntelLine(line:string) : Boolean;
var Reclen  : Integer;
    Loadadr : Word;
    RecType : Integer;
    CheckSum: Integer;
    Loop    : Integer;
    Temp    : String;
begin
    if line[1] <> ':' then begin
        write(char($07));
        MessageBox('File is not INTEL HEX format', nil, mfError + mfOkButton);
        ProcessIntelLine := False;
    end
    else begin
       if length(line) < 11 then begin
          write(char($07));
          MessageBox('Invalid line (too short)', nil, mfError + mfOkButton);
          ProcessIntelLine := False;
       end
       else begin
          if InvalidIntelLine(Line) then begin
             write(char($07));
             MessageBox('Invalid checksum', nil, mfError + mfOkButton);
             ProcessIntelLine := False;
          end
          else begin
             RecLen  := StrToInteger(line[2]+line[3]);
             Loadadr := StrToWord(line[4]+line[5]+line[6]+line[7]);
             RecType := StrToInteger(Line[8]+line[9]);
             Case RecType of
                 00 : begin {data record}
                          Loop := 0;
                          while Loop < (RecLen*2) do begin
                             cram[Loadadr+(Loop DIV 2)] := StrToInteger(Line[10+Loop] + Line[11+Loop]);
                             Loop := Loop + 2;
                          end;
                          ProcessIntelLine := true;
                       end;
                 01 :  begin
                           { PC := LoadAdr }
                           ProcessIntelLine := True;
                       end;
                 else  begin
                          write(char($07));
                          MessageBox('Unknown record type',nil,mfError+mfOkButton);
                          ProcessIntelLine := False;
                       end;
             end;
          end;
       end;
    end;
end;

{file >> 552}
function ProcessMotorolaLine(line:string) : Boolean;
var Reclen  : Integer;
    Loadadr : Word;
    RecType : Integer;
    CheckSum: Integer;
    Loop    : Integer;
    Temp    : String;
begin
    if (line[1] <> 'S') AND (line[1] <> 's') then begin
        write(char($07));
        MessageBox('File is not Motorola S format', nil, mfError + mfOkButton);
        ProcessMotorolaLine := False;
    end
    else begin
       if length(line) < 10 then begin
          write(char($07));
          MessageBox('Invalid line (too short)', nil, mfError + mfOkButton);
          ProcessMotorolaLine := False;
       end
       else begin
          if InvalidMotorolaLine(Line) then begin
             write(char($07));
             MessageBox('Invalid checksum', nil, mfError + mfOkButton);
             ProcessMotorolaLine := False;
          end
          else begin
             RecLen  := StrToInteger(line[3]+line[4]);
             Loadadr := StrToWord(line[5]+line[6]+line[7]+line[8]);
             RecType := StrToInteger(Line[2]);
             Case RecType of
                 1  : begin {data record}
                          Loop := 0;
                          while Loop < (RecLen*2) do begin
                             cram[Loadadr+(Loop DIV 2)] := StrToInteger(Line[9+Loop] + Line[10+Loop]);
                             Loop := Loop + 2;
                          end;
                          ProcessMotorolaLine := true;
                       end;
                 9  :  begin
                           { PC := LoadAdr }
                           ProcessMotorolaLine := True;
                       end;
                 else  begin
                          write(char($07));
                          MessageBox('Unknown record type',nil,mfError+mfOkButton);
                          ProcessMotorolaLine := False;
                       end;
             end;
          end;
       end;
    end;
end;

{ 552 >> file }
procedure WriteFile( Filename : String; startaddr, endaddr : Word; FType : FileType );
var line          : string;
    loop          : word;
    txtfile       : text;
    length        : word;   { number of bytes to dump       }
begin
    assign( txtfile, Filename );
    ReWrite( txtfile );
    length := startaddr;
    while length < endaddr do begin
        line := '';
        for loop := 0 to 15 do
            line := line + IntegerToString(cram[length+loop]);
        case FType of
           Intel    : writeintelrecord( txtfile, '00', length, line );
           Motorola : writemotorolarecord(txtfile,'S1',length, line );
        end;
        length := length + 16;
     end;
     case FType of
        Intel   : writeintelrecord( txtfile, '01', startaddr, '');
        Motorola: writemotorolarecord(txtfile,'S9',startaddr, '');
     end;
     Close( txtfile );
end;


{ 552 >> file }
procedure UpLoadFile( FileName, StartAddr, Endaddr : String; FType : FileType );
var OverWrite     : Boolean;
begin
    OverWrite := True;
    if fileexists( FileName ) then begin
       write(char($07));
       if MessageBox('File Exists. OVERWRITE? ', nil, mfWarning + mfOkCancel) = cmCancel then
           OverWrite := False
    end;
    {verify startaddr and endaddr by converting to word and range check}
    if strtoword(endaddr) < strtoword(startaddr) then begin
       write(char($07));
       MessageBox('End Address < Start Address', nil, mfError + mfOkButton)
    end
    else if strtoword(startaddr) > cramlimit then begin
       write(char($07));
       MessageBox('Start Address < $3fff', nil, mfError + mfOkButton)
    end
    else begin
       if OverWrite = true then begin
           Writefile( FileName, strtoword(startaddr), strtoword(endaddr), FType );
       end
       else begin
           write(char($07));
           MessageBox('File not uploaded', nil, mfWarning + mfOkButton);
       end;
    end;
end;

{file >> 552}
procedure DownLoadFile( FileName, Start, EndAddr : String; FType : FileType );
var line    : string;
    txtfile : text;
    Okay    : Boolean;
begin
    Okay := true;
    assign( txtfile, FileName );
    if fileexists( FileName ) = false then begin
        write(char($07));
        MessageBox('File does not exist', nil, mfError + mfOkButton)
    end
    else begin
        reset( txtfile );
        line := '';
        while (not eof(txtfile)) and (okay) do begin
            readln( txtfile, line );
            Case FType of
               Intel    : Okay := ProcessIntelLine(Line);
               Motorola : Okay := ProcessMotorolaLine(Line);
            end;
        end;
        Close(txtfile);
    end;
    Message( rwin,   evBroadcast, cmScrollBarChanged, nil );
    Message( cwin,   evBroadcast, cmScrollBarChanged, nil );
    Message( xwin,   evBroadcast, cmScrollBarChanged, nil );
    Message( asmwin, evBroadcast, cmScrollBarChanged, nil );
end;

procedure Transfer( CmdType : Integer );
var FDialog : PDialog;
    R       : TRect;
    FInfo   : FileInfo;
    Control : Word;
    Title   : String;
    FileName: String;
    StartAdr: String;
    EndAdr  : String;
    Ftype   : FileType;
begin
    FType := Intel;
    R.Assign(22,8,62,18);
    if cmdType = FILEUP then
       Title := 'Upload file from 552'
    else
       Title := 'Download file to 552';
    FDialog := New(PDialog, Init(R, Title ));
    with FDialog^ do begin
        if CmdType = FILEUP then begin
            R.Assign(17,3,23,4);
            FInfo.StartAdr := New(PInputLine, Init(R, 4));
            Insert(FInfo.StartAdr);
            R.Assign(1,3,15,4);
            FInfo.FStart := New(PLabel, Init(R,'~S~tart Address', Finfo.StartAdr));
            Insert(FInfo.FStart );
            R.Assign(17,5,23,6);
            FInfo.EndAdr := New(PInputLine, Init(R, 4));
            Insert(FInfo.EndAdr);
            R.Assign(1,5,15,6);
            FInfo.FEnd := New(PLabel, Init(R,'~E~nd Address', Finfo.EndAdr));
            Insert(FInfo.FEnd );
        end;
        R.Assign(3,7,9,9);
        Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
        R.Assign(10,7,22,9);
        Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
        R.Assign(25,3,38,5);
        SelectNext(False);
        Case CmdType of
            FILEUP : Begin
                        FInfo.FType := New(PRadioButtons, Init(R,
                        NewSItem('~I~ntel',
                        NewSItem('~M~otorola', nil))));
                      end;
            FILEDN :  Begin
                        FInfo.FType := New(PRadioButtons, Init(R,
                        NewSItem('~I~ntel',
                        NewSItem('~M~otorola', nil))));
                      end;
        end;
        Insert(FInfo.FType);
        R.Assign(25,2,35,3);
        Insert(New(PLabel, Init(R, 'File Type', nil)));
        R.Assign(11,1,23,2);
        FInfo.Name := New(PInputLine, Init(R, 22));
        Insert(FInfo.Name);
        R.Assign(1,1,10,2);
        FInfo.FName := New(PLabel, Init(R,'~F~ilename', FInfo.Name));
        Insert(FInfo.FName );
    end;
    Control := Desktop^.ExecView(FDialog);
    if Control = cmOk then begin
       Finfo.Name^.GetData(Filename);
       FInfo.FType^.GetData(FType);
       if CmdType = FILEUP then begin
          FInfo.StartAdr^.GetData(StartAdr);
          FInfo.EndAdr^.GetData(EndAdr);
       end;
       StrUpper(FileName);
       StrUpper(StartAdr);
       StrUpper(EndAdr);
       if FileName <> '' then begin
           case CmdType of
                FILEDN : DownLoadFile(FileName, StartAdr, EndAdr, FType );
                FILEUP : UpLoadFile(FileName, StartAdr, EndAdr, FType );
           end;
       end
       else begin
          write(char($07));
          MessageBox('No File Name specified', nil, mfError + mfOkButton);
       end;
    end;
    Dispose(FDialog, Done);
end;

procedure RunPCAtAddress;
var  MemAdr : string;
     MDialog : PDialog;
     R       : TRect;
     Control : Word;
     StartAdr: PInputLine;
begin
     Running80C552 := False;
     R.Assign(30,8,55,15);
     MDialog := New(PDialog, Init(R, 'RUN PC' ));
     with MDialog^ do begin
        R.Assign(3,4,9,6);
        Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
        R.Assign(10,4,22,6);
        Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
        R.Assign(17,2,23,3);
        StartAdr := New(PInputLine, Init(R, 4));
        Insert(StartAdr);
        R.Assign(1,2,15,3);
        Insert( New(PLabel, Init(R,'~P~C Address', StartAdr)));
     end;
     Control := Desktop^.ExecView(MDialog);
     if Control = cmOk then
     begin
        MDialog^.GetData(MemAdr);
        StrUpper(MemAdr);
        if (strtoword(MemAdr) > cramlimit) then begin
           write(char($07));
           MessageBox('Memory Address out of range',nil,mfError+mfOkButton);
        end
        else {send a run command, activate register window to foreground}
        begin
           PC := StrToWord(MemAdr);
           {broadcast event for all windows to update themselves}
           UpdateWindows;
           Running80C552 := True;
        end;
     end;
     Dispose(MDialog, Done);
     While Running80C552 do
     Begin
        if PC > cramlimit then begin
           write(char($07));
           MessageBox('Memory Address out of range',nil,mfError+mfOkButton);
           Running80C552 := false;
        end
        else
           ExecuteInstruction;
        If keypressed Then Running80C552 := false;
        If WinUpdate then UpDateWindows;
        {update the processor window only}
        if NOT WinUpDate then
           Message( rwin, evBroadcast, cmScrollBarChanged, nil );
     End;
     UpDateWindows;
end;

procedure RunPC;
begin
     Running80C552 := True;
     While Running80C552 do
     Begin
        if PC > cramlimit then begin
           write(char($07));
           MessageBox('Memory Address out of range',nil,mfError+mfOkButton);
           Running80C552 := false;
        end
        else
           ExecuteInstruction;
        If keypressed Then Running80C552 := false;
        if WinUpdate then UpDateWindows;
        {update the processor window only}
        if NOT WinUpDate then
           Message( rwin, evBroadcast, cmScrollBarChanged, nil );
     End;
     UpDateWindows;
end;

procedure ResetPC;
begin
    write(char($07));
    if MessageBox('Reset Target! Are you sure?',nil,mfWarning+mfOkCancel) = cmOk then begin
        ResetRegisters;
        Running80C552 := False;
    end;
    UpDateWindows;
end;

procedure HaltPC;
begin
     Running80C552 := false;
     UpDateWindows;
end;

procedure TracePC;
begin
     ExecuteInstruction;
     UpDateWindows;
end;

procedure ClearXMemory;
var loop : word;
begin
    for loop := 0 to xramlimit do
       xxram[loop] := $00;
    UpDateWindows;
end;

procedure FillXMemory;
var FMDialog: PDialog;
    R       : TRect;
    Control : Word;
    Title   : String;
    StartAdr: String;
    EndAdr  : String;
    FMByte  : String;
    FMRec   : FillMem;
    loop, wstart, wend : word;
    wfill : byte;
begin
    R.Assign(22,8,62,18);
    Title := 'Fill Memory with Byte';
    FMDialog := New(PDialog, Init(R, Title ));
    with FMDialog^ do begin
        R.Assign(17,1,23,2);
        FMRec.StartAdr := New(PInputLine, Init(R, 4));
        Insert(FMRec.StartAdr);
        R.Assign(1,1,15,2);
        FMRec.FMStart := New(PLabel, Init(R,'~S~tart Address', FMRec.StartAdr));
        Insert(FMRec.FMStart );
        R.Assign(17,3,23,4);
        FMRec.EndAdr := New(PInputLine, Init(R, 4));
        Insert(FMRec.EndAdr);
        R.Assign(1,3,15,4);
        FMRec.FMEnd := New(PLabel, Init(R,'~E~nd Address', FMRec.EndAdr));
        Insert(FMRec.FMEnd );
        R.Assign(17,5,21,6);
        FMRec.FillByte := New(PInputLine, Init(R, 2));
        Insert(FMRec.FillByte);
        R.Assign(1,5,15,6);
        FMRec.FMValue := New(PLabel, Init(R,'~F~ill Byte', FMRec.FillByte));
        Insert(FMRec.FMValue );
        R.Assign(3,7,9,9);
        Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
        R.Assign(10,7,22,9);
        Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
        SelectNext(False);
    end;
    Control := Desktop^.ExecView(FMDialog);
    if Control = cmOk then begin
       FMRec.StartAdr^.GetData(StartAdr);
       FMRec.EndAdr^.GetData(EndAdr);
       FMRec.FillByte^.GetData(FMByte);
       StrUpper(StartAdr);
       StrUpper(EndAdr);
       StrUpper(FMByte);
       if ValidHexStr(StartAdr) then
          if ValidHexStr( EndAdr ) then
             if ValidHexStr( FMByte ) then
             begin
                wstart := StrToWord( StartAdr );
                wend   := StrToWord( EndAdr );
                wfill  := StrToByte( FMByte );
               if wstart > xramlimit then begin
                  write(char($07));
                  MessageBox('Adr value > Top of Memory',nil,mfError+mfOkButton);
               end
               else if wend < wstart then begin
                  write(char($07));
                  MessageBox('End Adress < Start Address',nil,mfError+mfOkButton);
               end
               else if wend > xramlimit then begin
                  write(char($07));
                  MessageBox('End Adress > Top of Memory',nil,mfError+mfOkButton);
               end
               else begin
                  loop := wstart;
                  while loop <= wend do begin
                     xxram[loop] := wfill;
                     loop := loop + 1;
                  end;
               end;
             end
             else begin
                 write(char($07));
                 MessageBox('Invalid FillByte. Hexadecimal only',nil,mfError+mfOkButton);
             end
          else begin
             write(char($07));
             MessageBox('Invalid End Address. Hexadecimal only',nil,mfError+mfOkButton);
          end
       else begin
          write(char($07));
          MessageBox('Invalid Start Address. Hexadecimal only',nil,mfError+mfOkButton);
       end;
    end;
    Dispose(FMDialog, Done);
    UpDateWindows;
end;


constructor scrolltype.init( var r:trect; anumcols:integer; ahscrollbar, avscrollbar :pscrollbar; scrollertype : viewmodel );
begin
     tlistviewer.init(r, anumcols, nil, avscrollbar);
     scroller := scrollertype;
     scrolltype.setstate( sfselected OR sfactive OR sfvisible OR sfcursorvis, true );
     case scrollertype of
          assembly         : begin
                                topitem := 14;
                                scrolltype.setrange( topitem + 1 );
                             end;
          specialfunctregs : begin
                                topitem := 55;
                                scrolltype.setrange( topitem + 1 );
                             end;
          regs             : begin
                                topitem := 6;
                                scrolltype.setrange( topitem + 1 );
                             end;
          interndata       : begin
                                topitem := 255;
                                scrolltype.setrange( topitem + 1 );
                             end;
          programdata       : begin
                                topitem := 2047;
                                scrolltype.setrange( topitem + 1 );
                             end;
          externdata       : begin
                                topitem := 2047;
                                scrolltype.setrange( topitem + 1 );
                             end;
          ports            : begin
                                topitem := 5;
                                scrolltype.setrange( topitem + 1 );
                             end;
          pwmo            : begin
                                topitem := 1;
                                scrolltype.setrange( topitem + 1 );
                             end;
     end;
     scrolltype.focusitem(0);
end;

function Scrolltype.gettext(item:integer; maxlen:integer) : string;
var st, CmdResult, Instr, PCAdr : string;
    PCTemp : Word;
    loop, Instrptr : integer;
    pwmb : byte;
begin
     st := '';
     case scroller of
          assembly          : begin
                                 PCTemp := PC;
                                 if PCTemp > (xramlimit - 20) then
                                    st := 'PC address is out of range'
                                 else
                                 begin
                                    CmdResult := '';
                                    for loop := 0 to 30 do
                                       CmdResult := CmdResult + IntegerToString(cram[PCTemp+loop]);
                                    loop := 0;
                                    InstrPtr := 1;
                                    Instr := CmdResult[InstrPtr]+CmdResult[InstrPtr+1];
                                    while loop < item do
                                    begin
                                       InstrPtr := InstrPtr + (Instrs[StrtoInteger(Instr)].nbytes * 2 );
                                       Instr := CmdResult[InstrPtr]+CmdResult[InstrPtr+1];
                                       loop := loop + 1;
                                    end;
                                    PCAdr := WordtoString(PCTemp+((InstrPtr-1) DIV 2));
                                    st := PCAdr +'  '+DecodeInstruction(CmdResult,InstrPtr, PCTemp+((InstrPtr-1) DIV 2));
                                 end;
                              end;
          specialfunctregs  : begin
                                 st  := sfr[item].name + ' ';
                                 CmdResult := IntegerToString(sfrram[sfr[item].addr] );
                                 st  := st+strtobin(CmdResult)+ '  '+CmdResult;
                              end;
          regs              : begin
                                  st  := reg[item].name + ' ';
                                  case item of
                                      0, 1, 2: {acc, b, psw}
                                         begin
                                            CmdResult := IntegerToString(sfrram[reg[item].addr] );
                                            st := st+strtobin(CmdResult)+'  '+ CmdResult;
                                         end;
                                      3: begin  {sp}
                                            CmdResult := IntegerToString(sfrram[reg[item].addr ]);
                                            st := st+'          '+ CmdResult;
                                         end;
                                      4: begin {pc}
                                            CmdResult := WordToString(PC);
                                            st := st+'        '+ CmdResult;
                                         end;
                                      5: begin {dptr}
                                            CmdResult := IntegerToString(sfrram[DPH])+IntegerToString(sfrram[DPL]);
                                            st := st+'        '+ CmdResult;
                                         end;
                                      6: begin {cycle count}
                                            Str(Cycles:4, CmdResult);
                                            st := st+'Cycles  '+ CmdResult;
                                         end;
                                  end;
                              end;
          interndata        : begin
                                  st  := integertostring( item );
                                  CmdResult := IntegerToString(iram[item]);
                                  st  := st + '  ........  ' + CmdResult;
                              end;
          programdata        : begin
                                  st := wordtostring( item * 8);
                                  CmdResult := '';
                                  for loop := 0 to 7 do
                                     CmdResult := CmdResult + IntegerToString(cram[(item*8)+loop]);
                                  st := st + '  ' + CmdResult + '  ' + strtoascii(CmdResult);
                              end;
          externdata        : begin
                                  st := wordtostring( item * 8);
                                  CmdResult := '';
                                  for loop := 0 to 7 do
                                     CmdResult := CmdResult + IntegerToString(xxram[(item*8)+loop]);
                                  st := st + '  ' + CmdResult + '  ' + strtoascii(CmdResult);
                              end;
          ports            : begin
                                  st := port552[item].name;
                                  CmdResult := IntegerToString(sfrram[port552[item].addr] );
                                  st := st+strtobin(CmdResult)+'  '+ CmdResult;
                              end;
          pwmo             : begin
                                  Str(item, CmdResult);
                                  st := 'PWM'+CmdResult;
                                  pwmb := sfrram[PWM0+item];
                                  if pwmb = $00 then CmdResult := '1'
                                  else if pwmb = $ff then CmdResult := '0'
                                  else begin
                                      if pwmb <= pwmcounter then
                                         CmdResult := '1'
                                      else
                                         CmdResult := '0';
                                  end;
                                  st := st + '           ' + CmdResult;
                              end;
     end;
     gettext := st;
end;

function scrolltype.getpalette : PPalette;
const
{    cmytl = #6#6#7#7#6; { this leaves bar in all windows }
     cmytl = #6#6#7#6#6;  {this leaves bar only in active window}
     pmytl : string[length(cmytl)] = cmytl;
begin
     getpalette := @pmytl;
end;

procedure scrolltype.handleevent(var event : tevent );
var DDialog : PDialog;
    R    : Trect;
    PVal : PInputLine;
    DVal : String;
    CmdResult  : String;
    procedure getportvalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'Port Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, Port552[self.focused].Name+'New value',nil)));
           R.Assign(17,2,21,3);
           PVal := New(PInputLine, Init(R, 2));
           Insert(PVal);
        end;
        DVal := IntegerToString(sfrram[Port552[Self.Focused].addr]);
        DDialog^.SetData(DVal);
        if Self.Focused = 5 then begin
           write(char($07));
           MessageBox('Port 5 is RD only',nil,mfError+mfOkButton)
        end
        else begin
           if Desktop^.ExecView(DDialog) <> cmCancel then begin
              DDialog^.GetData(DVal);
              StrUpper(DVal);
              if ValidHexStr(DVal) then
                 sfrram[Port552[self.focused].Addr] := byte(StrToInteger(DVal))
              else begin
                 write(char($07));
                 MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
              end;
              Message( pwin, evBroadcast, cmScrollBarChanged, nil );
              Message( sfrwin, evBroadcast, cmScrollBarChanged, nil );
           end;
        end;
        Dispose(DDialog, Done);
     end;
    procedure getidatavalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'IData Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, 'New value',nil)));
           R.Assign(17,2,21,3);
           PVal := New(PInputLine, Init(R, 2));
           Insert(PVal);
        end;
        DVal := IntegerToString(iram[Self.Focused]);
        DDialog^.SetData(DVal);
        if Desktop^.ExecView(DDialog) <> cmCancel then begin
           DDialog^.GetData(DVal);
           StrUpper(DVal);
           if ValidHexStr(DVal) then
              iram[self.focused] := Byte(StrToInteger(DVal))
            else begin
               write(char($07));
               MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
           end;
           Message( iwin, evBroadcast, cmScrollBarChanged, nil );
        end;
        Dispose(DDialog, Done);
     end;
    procedure getsfrvalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'SFR Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, 'New value',nil)));
           R.Assign(17,2,21,3);
           PVal := New(PInputLine, Init(R, 2));
           Insert(PVal);
        end;
        DVal := IntegerToString(sfrram[sfr[Self.Focused].addr]);
        DDialog^.SetData(DVal);
        if Sfr[Self.Focused].rdwr = false then begin
            write(char($07));
            MessageBox('Monitor will not alter Sfr register',nil,mfError+mfOKButton);
        end
        else begin
           if Desktop^.ExecView(DDialog) <> cmCancel then begin
              DDialog^.GetData(DVal);
              StrUpper(DVal);
              if ValidHexStr(DVal) then
                 sfrram[sfr[Self.Focused].addr] := Byte(StrToInteger(DVal))
              else begin
                 write(char($07));
                 MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
              end;
              UpdateWindows;
           end;
        end;
        Dispose(DDialog, Done);
     end;
    procedure getregsvalue;
    begin
        if Self.Focused <> 6 then { for all except clock cycles }
        begin
           R.Assign(30,8,55,15);
           DDialog := New(PDialog, Init(R, 'Register Value?' ));
           with DDialog^ do begin
              R.Assign(3,4,9,6);
              Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
              R.Assign(10,4,22,6);
              Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
              R.Assign(1,2,15,3);
              Insert(New(PLabel, Init(R, 'New value',nil)));
              Case Self.Focused of
                0, 1, 2, 3: begin
                              R.Assign(17,2,21,3);
                              PVal := New(PInputLine, Init(R, 2));
                            end;
                4, 5      : begin
                              R.Assign(17,2,23,3);
                              PVal := New(PInputLine, Init(R, 4));
                            end;
              end;
              Insert(PVal);
           end;
           Case Self.Focused of
               0, 1, 2, 3 : Dval := IntegerToString(sfrram[reg[Self.Focused].addr] );
                        4 : Dval := WordToString( PC );
                        5:  begin {dptr}
                               Dval := IntegerToString(sfrram[$83]);
                               Dval := Dval + IntegerToString(sfrram[$82]);
                            end;
           end;
           DDialog^.SetData(DVal);
           if Desktop^.ExecView(DDialog) <> cmCancel then begin
              DDialog^.GetData(DVal);
              StrUpper(DVal);
              if ValidHexStr(DVal) then begin
                 Case Self.Focused of
                     0, 1, 2, 3 : sfrram[reg[Self.Focused].addr] := StrToByte(Dval);
                              4 : if (strtoword(DVal) > xramlimit) then begin
                                     write(char($07));
                                     MessageBox('Memory Address out of range',nil,mfError+mfOkButton);
                                  end
                                  else
                                     PC := StrToWord(Dval);
                              5:  begin {dptr}
                                     while length(Dval) < 4 do
                                        Dval := '0' + Dval;
                                     sfrram[$83] := Byte(StrToInteger(Dval[1]+Dval[2]));
                                     sfrram[$82] := Byte(StrToInteger(Dval[3]+Dval[4]));
                                   end;
                 end;
              end
              else begin
                 write(char($07));
                 MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
              end;
              UpdateWindows;
           end;
           Dispose(DDialog, Done);
        end;
     end;

begin
    tlistviewer.handleevent(event);
    if event.what = evkeydown then
    begin
        case event.keycode of
          kbenter : begin
                       case scroller of
                          {assembly,specialfuncregs,regs,interndata}
                          {externdata,ports}
                          ports            : getportvalue;
                          interndata       : getidatavalue;
                          specialfunctregs : getsfrvalue;
                          regs             : getregsvalue;
                       end;
                       clearevent(event);
                     end;
        end;
    end
    else
       exit;
end;

constructor scrollwindow.init( var r : trect; wintitle : string;  winnum : word;
            scrollertype : viewmodel );
begin
     Twindow.init( r, wintitle, 0 );
     getcliprect( r );
     r.grow( -1, -1 );
     setstate(sfshadow, false);
     flags := 0;
     options := options or ofTileable;
     vscrollbar := standardscrollbar( sbvertical OR sbhandlekeyboard );
     interior := new( scrtype, Init( r, 1, nil, vscrollbar, scrollertype ) );
     insert( interior );
end;

constructor mon.Init;
var  R       : TRect;
     Startup : PDialog;
     Control : Word;
begin
     Running80C552 := False;
     WinUpdate := True;
     Cycles := 0;
     RegBank := 0;
     PwmCounter := 0;  { driven by prescaler value in sfrram[PWMP] }
     ResetRegisters;
     tapplication.init;
     RegisterObjects;
     RegisterViews;
     RegisterMenus;
     RegisterDialogs;
     RegisterApp;
     getextent(r);
     R.Assign(20,10,60,20);
     Startup := New(PDialog, Init(R, '80C552 Simulator for DOS' ));
     Startup^.Options := Startup^.Options + ofcentered;
     with Startup^ do begin
         R.Assign(3,7,9,9);
         Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
         R.Assign(1,2,30,3);
         Insert(New(Plabel, Init(R, 'Version '+VersionNo, nil)));
         R.Assign(1,4,30,5);
         Insert(New(PLabel, Init(R, 'Copyright B Brown, 1991-1993',nil)));
         R.Assign(1,5,30,6);
         Insert(New(PLabel, Init(R, 'email: brian@brian.cit.ac.nz',nil)));
     end;
     write(char($07));
     control := Desktop^.ExecView(Startup);
     Dispose(Startup,Done);
     inc(wincount);
     rdat.assign( 0,0,22,9);
     rwin := new(scrwindow, init(rdat, 'Registers', wincount, regs ) );
     desktop^.insert(rwin);
     inc(wincount);
     sfrdat.assign( 0,9,22,23);
     sfrwin := new(scrwindow, init(sfrdat, 'Sfr registers ', wincount, specialfunctregs ) );
     desktop^.insert(sfrwin);
     inc(wincount);
     asmdat.assign( 22,0,60,9);
     asmwin := new(scrwindow, init(asmdat, 'Assembly', wincount, assembly ) );
     desktop^.insert(asmwin);
     inc(wincount);
     cdat.assign( 22,9,60,14);
     cwin := new(scrwindow, init(cdat, 'Code', wincount, programdata ) );
     desktop^.insert(cwin);
     inc(wincount);
     xdat.assign( 22,14,60,23);
     xwin := new(scrwindow, init(xdat, 'Xdata', wincount, externdata ) );
     desktop^.insert(xwin);
     inc(wincount);
     pdat.assign( 60,0,80,8);
     pwin := new(scrwindow, init(pdat, 'Ports', wincount, ports ) );
     desktop^.insert(pwin);
     inc(wincount);
     pwmdat.assign( 60,8,80,12);
     pwmwin := new(scrwindow, init(pwmdat, 'PWM Output', wincount, pwmo));
     desktop^.insert(pwmwin);
     inc(wincount);
     idat.assign( 60,12,80,23);
     iwin := new(scrwindow, init(idat, 'Idata', wincount, interndata ) );
     desktop^.insert(iwin);
     rwin^.select;
end;

procedure mon.handleevent( var event : tevent );
   procedure QuitNow;
   begin
      write(char($07));
      if MessageBox('Exit Program? ', nil, mfWarning + mfOkCancel) = cmCancel then
         ClearEvent(Event);
   end;
begin
     if event.what = evcommand then
        if event.command = cmQuit then QuitNow;
     tapplication.handleevent(event);
     if event.what = evcommand then begin
          case event.command of
              cmDownload : Transfer(FILEDN);
              cmUpload   : Transfer(FILEUP);
              cmRegisters: rwin^.select;
              cmXdata    : xwin^.select;
              cmIData    : iwin^.select;
              cmAssembly : asmwin^.select;
              cmSFR      : sfrwin^.select;
              cmPorts    : pwin^.select;
              cmCode     : cwin^.select;
              cmGoPCAdr  : RunPCAtAddress;
              cmChDir    : ChangeDir;
              cmReset    : ResetPC;
              cmHaltPC   : HaltPC;
              cmRunPC    : RunPC;
              cmTracePC  : TracePC;
              cmUpdate   : UpdateWindows;
              cmToggle   : if WinUpdate then WinUpdate := False else WinUpdate := True;
              cmClearMem : ClearXMemory;
              cmFillMem  : FillXMemory;
              cmClearCyl : begin Cycles := 0; UpDateWindows; end;
          else
              exit
          end;
          clearevent(event);
     end;
end;

procedure mon.initmenubar;
var r : trect;
begin
     getextent(r);
     r.b.y := r.a.y + 1;
     menubar := New( Pmenubar, Init(r, Newmenu(
             NewSubMenu('~F~ile  ', hcNocontext, NewMenu(
                 NewItem('~C~hange Dir     ','F2', kbF2, cmChDir, hcnocontext,
                 NewItem('~D~ownload to 552','F3', kbF3, cmdownload, hcNoContext,
                 NewItem('~U~pload from 552','F4', kbF4, cmupload, hcnocontext,
                 nil)))),
             NewSubMenu('~5~52Processor ', hcNocontext, NewMenu(
                 NewItem('~C~lear Xdata ','ALT-N', kbALTN, cmClearMem,hcnocontext,
                 NewItem('Clear C~y~cles','ALT-Y', kbALTY, cmClearCyl,hcnocontext,
                 NewItem('Fi~l~l Xdata  ','ALT-L', kbALTL, cmFillMem, hcnocontext,
                 NewItem('~G~o @Address ','ALT-G', kbALTG, cmGoPcAdr, hcnocontext,
                 NewItem('~H~alt PC     ','F5   ', kbF5,   cmHaltPC,  hcnocontext,
                 NewItem('~R~eset Target','F6   ', kbF6,   cmReset,   hcnocontext,
                 NewItem('~R~eset Target','F6   ', kbF6,   cmReset,   hcnocontext,
                 NewItem('~T~race PC    ','F7   ', kbF7,   cmTracePC, hcnocontext,
                 NewItem('R~u~n PC      ','F8   ', kbF8,   cmRunPC,   hcnocontext,
                 nil)))))))))),
             NewSubMenu('~W~indow  ', hcNoContext, NewMenu(
                 NewItem('~A~ssembly  ','ALT-A',kbALTA, cmassembly,  hcnocontext,
                 NewItem('~I~data     ','ALT-I',kbALTI, cmidata,     hcnocontext,
                 NewItem('~P~orts     ','ALT-P',kbALTP, cmPorts,     hcnocontext,
                 NewItem('~R~egisters ','ALT-R',kbALTR, cmregisters, hcnocontext,
                 NewItem('~S~FRs      ','ALT-S',kbALTS, cmsfr,       hcnocontext,
                 NewItem('~C~ode      ','ALT-C',kbALTC, cmcode,      hcnocontext,
                 NewItem('~X~data     ','ALT-C',kbALTX, cmxdata,     hcnocontext,
                 NewItem('~N~ext      ','F9',   kbF9,   cmnext,      hcnocontext,
                 NewItem('Update windows','ALT-F1',kbALTF1,cmUpdate,hcnocontext,
                 NewItem('Toggle Run Update','ALT-F2',kbALTF2,cmToggle,hcnocontext,
                 nil))))))))))),
             nil))))))
end;

procedure mon.initstatusline;
var r : trect;
begin
     getextent(R);
     r.a.y := r.b.y - 1;
     statusline := New(PstatusLine, Init(R,
        NewStatusDef(0, $ffff,
           NewStatusKey('~F10~Menu', kbF10,   cmMenu,
           NewStatusKey('~AltQ~Exit', kbAltQ,  cmQuit,
           NewStatusKey('~F5~Halt',  kbF5, cmHaltPC,
           NewStatusKey('~F6~Reset', kbF6, cmReset,
           NewStatusKey('~F7~Trace', kbF7, cmTracePC,
           NewStatusKey('~F8~Run',   kbF8, cmRunPC,
           NewStatusKey('~F9~Next-Window', kbF9,  cmNext,
           nil))))))),
        nil)
     ))
end;

procedure Mon.ChangeDir;
var  D:PChDirDialog;
begin
    D := New(PChDirDialog, Init(cdNormal, 101));
    if ValidView(D) <> nil then begin
       DeskTop^.ExecView(D);
       Dispose(D, Done);
    end;
end;

procedure Mon.OutOfMemory;
begin
     MessageBox('Not Enough memory for this operation.', nil, mfError + mfOkButton);
end;

destructor mon.Done;
begin
     TApplication.Done;
end;

begin
     monitor.init;
     monitor.run;
     monitor.done;
end.

