{ 552 monitor program }

program newmon12;

{$M 16384,16384,655360 }  {stacksize, heapmin, heapmax                       }
{$X+}        {allow functons to be treated as procedures, discard results    }
{$S+}        {check stack overflow at beginning of each function             }

{11-12-1991  add handle event for tlistviewer reg, port, idata, sfr          }
{12-12-1991  added edit for sfr,regs,ports,idata, changed some sfrs to rdonly}
{            removed block record and asciihex space record format support   }
{13-12-1991  add halt pc and go pc, change to monv30                         }
{21-12-1991  switched to monv31                                              }
{21-12-1991  adding terminal interface window                                }
{            fixed bug in resetpc, read bytes from target when esc           }
{            added short cut keys in initmenu using tidle characters         }
{            fixed bug in editor, now invokes batch file 'edit.bat'          }
{            in mon.idle, updates windows about every seven seconds          }
{25-12-1991  terminal interface added                                        }
{26-12-1991  handlers232 altered to insert CR if line too long               }
{            altered terminal window to full screen size                     }
{31-12-1991  changed rs232 routines to match termnal program                 }
{            checks if interrupt installed etc, lot cleaner now              }
{            added update window to window menu, ALT-F1                      }
{01-01-1992  changed rs232 routine so only one installable                   }
{NOTE: There is a memory disposal bug in ViewFile!                           }

uses objects, drivers, views, menus, app, dialogs, dos, crt, memory, Calc,
     editors, buffers, fviewer, msgbox, Gadgets, stddlg, textview;

type
    viewmodel = ( regs, externdata, interndata, assembly, specialfunctregs, ports );

    mon = object(Tapplication)
        Clock : PClockView;
        Heap  : PHeapView;
        constructor Init;
        procedure   InitMenuBar; virtual;
        procedure   InitStatusLine; virtual;
        procedure   HandleEvent( var Event: TEvent ); virtual;
        procedure   OutOfMemory; virtual;
        procedure   ChangeDir;
        procedure   OpenFile(WildCard : PathStr);
        procedure   ViewFile(FileName : PathStr);
        procedure   Idle; virtual;
        destructor  Done; virtual;
    end;

    scrtype = ^scrolltype;
    scrolltype = object(tlistviewer)
      scroller : viewmodel;
      constructor init( var r:trect; anumcols:integer; ahscrollbar, avscrollbar:pscrollbar;
                  scrollertype : viewmodel );
      function    gettext( item:integer; maxlen:integer) : string; virtual;
      function    getpalette : Ppalette; virtual;
      procedure   HandleEvent( var Event: TEvent ); virtual;
    end;
    scrwindow = ^scrollwindow;
    scrollwindow = object(twindow)
      vscrollbar : pscrollbar;
      interior   : scrtype;
      constructor init( var r:trect; wintitle:string; winnum : word;
                  scrollertype : viewmodel );
    end;

    MyTerm = ^Terminal;
    Terminal = object(TTerminal)
      procedure HandleEvent(var Event:TEvent); virtual;
    end;
    TermWin = ^TTerminalWindow;
    TTerminalWindow = object(TWindow)
      constructor Init(Bounds: TRect; WinTitle: String; WindowNo: Word;
        var Interior: MyTerm; ABufSize: Word);
      function MakeInterior(Bounds: TRect; ABufSize: Word): MyTerm;
      destructor Done; virtual;
    end;

    sfrmodel = record
       name : string[5];
       addr : string[2];
       rdwr : boolean;
    end;

    regmodel = record
       name : string[5];
       addr : string[2];
    end;

    portmodel = record
       name : string[5];
       addr : string[2];
    end;

    AddressingMode = (none, addr11, addr16, dir7, dir10, data8, data16, rel,
        rel10, bit7, bit10, bitrel, dirdata, predir, dirdir, datarel, dirrel,
        dirrel7 );

    Instructions = record
       name   : string[15];
       nbytes : integer;
       adrmode: addressingmode;
    end;

    FileType = (Intel, Motorola);

    FileInfo = Record
      FName   : Plabel;
      Name    : PInputLine;
      FStart  : PLabel;
      StartAdr: PInputLine;
      FEnd    : PLabel;
      EndAdr  : PInputLine;
      FType   : PRadioButtons;
    end;

    localecho = (fullduplex, halfduplex);
    ParityBits= (Odd, Even, NoParity);
    DataBits  = (Seven, Eight);
    StopBits  = (One, Two);
    BaudRates = (b1200, b2400, b4800, b9600);
    ComPorts  = (Com1, Com2);

    ComportControl = Record
       Port  : Word;
       Echo  : Word;
       Baud  : Word;
       Stop  : Word;
       Data  : Word;
       Parity: Word;
    end;

    ComInfo = Record
       Echo  : LocalEcho;
       Baud  : BaudRates;
       Stop  : StopBits;
       Data  : DataBits;
       Parity: ParityBits;
    end;

const
     HeapSize       = 32 * (1024 div 16);  {for use in editor     }
     bufflimit      = 2000;
     PICCtrl        = $20;
     EOI            = $20;
     PICMask        = $21;
     DLL            = 0;        { divisor latch low byte          }
     DLH            = 1;        { divisor latch high byte         }
     THR            = 0;        { transmit hold register          }
     RBR            = 0;        { recieve buffer register         }
     IER            = 1;        { interrupt enable register       }
     LCR            = 3;        { line control register           }
     MCR            = 4;        { modem control register          }
     LSR            = 5;        { line status register            }
     MSR            = 6;        { modem status register           }
     RTS            = $02;      { request to send                 }
     CTS            = $10;      { clear to send                   }
     DTR            = $01;      { data terminal ready             }
     DSR            = $20;      { data set ready                  }
     THRE           = $20;      { transmit hold register empty    }
     RBF            = $01;      { recieve buffer full             }
     DISINT         = $00;      { disable interrupts              }
     ABRG           = $80;      { access baud rate generator      }
     com1int        = $0c;
     com2int        = $0b;
     CR             = $0d;
     LF             = $0a;
     SPACE          = $20;
     MAXTIMEOUT     = $8000;

     FILEUP         = 0;
     FILEDN         = 1;
     cmDownLoad     = 101;
     cmUpLoad       = 102;
     cmRegisters    = 103;
     cmXdata        = 104;
     cmIdata        = 106;
     cmAssembly     = 107;
     cmSFR          = 108;
     cmPorts        = 109;
     cmCalc         = 111;
     cmDos          = 112;
     cmHaltPC       = 113;
     cmRunPC        = 114;
     cmTerminal     = 115;
     cmViewFile     = 116;
     cmChDir        = 117;
     cmEdit         = 118;
     cmGoPCAdr      = 119;
     cmReset        = 120;
     cmTracePC      = 121;
     cmTermOpts     = 122;
     cmUpdate       = 123;

     wincount  : integer = 0;

     Reg       : array[0..5]   of regmodel = (
          (name : 'Acc  '; addr : 'E0' ),
          (name : 'B    '; addr : 'F0'),
          (name : 'PSW  '; addr : 'D0'),
          (name : 'SP   '; addr : '81'),
          (name : 'PC   '; addr : '00'),
          (name : 'DPTR '; addr : '00') );
     Sfr       : array[0..55]  of sfrmodel = (
          (name : 'P0   '; addr : '80'; rdwr : true ),
          (name : 'SP   '; addr : '81'; rdwr : false),
          (name : 'DPL  '; addr : '82'; rdwr : true ),
          (name : 'DPH  '; addr : '83'; rdwr : true ),
          (name : 'PCON '; addr : '87'; rdwr : true ),
          (name : 'TCON '; addr : '88'; rdwr : false),
          (name : 'TMOD '; addr : '89'; rdwr : false),
          (name : 'TL0  '; addr : '8A'; rdwr : false),
          (name : 'TL1  '; addr : '8B'; rdwr : false),
          (name : 'TH0  '; addr : '8C'; rdwr : false),
          (name : 'TH1  '; addr : '8D'; rdwr : false),
          (name : 'P1   '; addr : '90'; rdwr : true ),
          (name : 'S0CON'; addr : '98'; rdwr : false),
          (name : 'S0BUF'; addr : '99'; rdwr : false),
          (name : 'P2   '; addr : 'A0'; rdwr : true ),
          (name : 'IEN0 '; addr : 'A8'; rdwr : false),
          (name : 'CML0 '; addr : 'A9'; rdwr : true ),
          (name : 'CML1 '; addr : 'AA'; rdwr : true ),
          (name : 'CML2 '; addr : 'AB'; rdwr : true ),
          (name : 'CTL0 '; addr : 'AC'; rdwr : false),
          (name : 'CTL1 '; addr : 'AD'; rdwr : false),
          (name : 'CTL2 '; addr : 'AE'; rdwr : false),
          (name : 'CTL3 '; addr : 'AF'; rdwr : false),
          (name : 'P3   '; addr : 'B0'; rdwr : false),
          (name : 'IP0  '; addr : 'B8'; rdwr : true ),
          (name : 'P4   '; addr : 'C0'; rdwr : true ),
          (name : 'P5   '; addr : 'C4'; rdwr : false),
          (name : 'ADCON'; addr : 'C5'; rdwr : true ),
          (name : 'ADCH '; addr : 'C6'; rdwr : false),
          (name : 'TM2IR'; addr : 'C8'; rdwr : true ),
          (name : 'CMH0 '; addr : 'C9'; rdwr : true ),
          (name : 'CMH1 '; addr : 'CA'; rdwr : true ),
          (name : 'CMH2 '; addr : 'CB'; rdwr : true ),
          (name : 'CTH0 '; addr : 'CC'; rdwr : false),
          (name : 'CTH1 '; addr : 'CD'; rdwr : false),
          (name : 'CTH2 '; addr : 'CE'; rdwr : false),
          (name : 'CTH2 '; addr : 'CF'; rdwr : false),
          (name : 'PSW  '; addr : 'D0'; rdwr : true ),
          (name : 'S1CON'; addr : 'D8'; rdwr : true ),
          (name : 'S1STA'; addr : 'D9'; rdwr : false),
          (name : 'S1DAT'; addr : 'DA'; rdwr : true ),
          (name : 'S1ADR'; addr : 'DB'; rdwr : true ),
          (name : 'ACC  '; addr : 'E0'; rdwr : true ),
          (name : 'IEN1 '; addr : 'E8'; rdwr : true ),
          (name : 'TM2CO'; addr : 'EA'; rdwr : true ),
          (name : 'CTCON'; addr : 'EB'; rdwr : true ),
          (name : 'TML2 '; addr : 'EC'; rdwr : false),
          (name : 'TMH2 '; addr : 'ED'; rdwr : false),
          (name : 'STE  '; addr : 'EE'; rdwr : true ),
          (name : 'RTE  '; addr : 'EF'; rdwr : true ),
          (name : 'B    '; addr : 'F0'; rdwr : true ),
          (name : 'IP1  '; addr : 'F8'; rdwr : true ),
          (name : 'PWM0 '; addr : 'FC'; rdwr : true ),
          (name : 'PWM1 '; addr : 'FD'; rdwr : true ),
          (name : 'PWMP '; addr : 'FE'; rdwr : true ),
          (name : 'T3   '; addr : 'FF'; rdwr : true ) );

     Port552   : array[0..5]   of portmodel = (
          (name : 'P0  '; addr : '80' ),
          (name : 'P1  '; addr : '90' ),
          (name : 'P2  '; addr : 'A0' ),
          (name : 'P3  '; addr : 'B0' ),
          (name : 'P4  '; addr : 'C0' ),
          (name : 'P5  '; addr : 'C4' ));

     hexdigits : array[0..15] of char = ( '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F' );

     binvalues : array[0..15] of string[4] = (
          ( '0000' ), ( '0001' ), ( '0010' ), ( '0011' ),
          ( '0100' ), ( '0101' ), ( '0110' ), ( '0111' ),
          ( '1000' ), ( '1001' ), ( '1010' ), ( '1011' ),
          ( '1100' ), ( '1101' ), ( '1110' ), ( '1111' ));

Instrs : Array[0..$FF] of Instructions = (
(name : 'NOP            '; nbytes : 1; adrmode : none   ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'LJMP  XXXX     '; nbytes : 3; adrmode : addr16 ),
(name : 'RR    A        '; nbytes : 1; adrmode : none   ),
(name : 'INC   A        '; nbytes : 1; adrmode : none   ),
(name : 'INC   XX       '; nbytes : 2; adrmode : dir7   ),
(name : 'INC   @R0      '; nbytes : 1; adrmode : none   ),
(name : 'INC   @R1      '; nbytes : 1; adrmode : none   ),
(name : 'INC   R0       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R1       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R2       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R3       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R4       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R5       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R6       '; nbytes : 1; adrmode : none   ),
(name : 'INC   R7       '; nbytes : 1; adrmode : none   ),
{10-1f}
(name : 'JBC   XX, XX   '; nbytes : 3; adrmode : bitrel ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'LCALL XXXX     '; nbytes : 3; adrmode : addr16 ),
(name : 'RRC   A        '; nbytes : 1; adrmode : none   ),
(name : 'DEC   A        '; nbytes : 1; adrmode : none   ),
(name : 'DEC   XX       '; nbytes : 2; adrmode : dir7   ),
(name : 'DEC   @R0      '; nbytes : 1; adrmode : none   ),
(name : 'DEC   @R1      '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R0       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R1       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R2       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R3       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R4       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R5       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R6       '; nbytes : 1; adrmode : none   ),
(name : 'DEC   R7       '; nbytes : 1; adrmode : none   ),
{20-2f}
(name : 'JB    XX, XX   '; nbytes : 3; adrmode : bitrel ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'RET            '; nbytes : 1; adrmode : none   ),
(name : 'RL    A        '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'ADD   A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'ADD   A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'ADD   A, R7    '; nbytes : 1; adrmode : none   ),
{30-3f}
(name : 'JNB   XX, XX   '; nbytes : 3; adrmode : bitrel ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'RETI           '; nbytes : 1; adrmode : none   ),
(name : 'RLC   A        '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'ADDC  A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'ADDC  A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'ADDC  A, R7    '; nbytes : 1; adrmode : none   ),
{40-4f}
(name : 'JC    XX       '; nbytes : 2; adrmode : rel    ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'ORL   XX, A    '; nbytes : 2; adrmode : predir ),
(name : 'ORL   XX,#XX   '; nbytes : 3; adrmode : dirdata),
(name : 'ORL   A,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'ORL   A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'ORL   A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'ORL   A, R7    '; nbytes : 1; adrmode : none   ),
{50-5f}
(name : 'JNC   XX       '; nbytes : 2; adrmode : rel    ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'ANL   XX, A    '; nbytes : 2; adrmode : predir ),
(name : 'ANL   XX,#XX   '; nbytes : 3; adrmode : dirdata),
(name : 'ANL   A,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'ANL   A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'ANL   A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'ANL   A, R7    '; nbytes : 1; adrmode : none   ),
{60-6f}
(name : 'JZ    XX       '; nbytes : 2; adrmode : rel    ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'XRL   XX, A    '; nbytes : 2; adrmode : predir ),
(name : 'XRL   XX,#XX   '; nbytes : 3; adrmode : dirdata),
(name : 'XRL   A, #XX   '; nbytes : 2; adrmode : data8  ),
(name : 'XRL   A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'XRL   A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'XRL   A, R7    '; nbytes : 1; adrmode : none   ),
{70-7f}
(name : 'JNZ   XX       '; nbytes : 2; adrmode : rel    ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'ORL   C, XX    '; nbytes : 2; adrmode : bit10  ),
(name : 'JMP   @A+DPTR  '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV   XX,#XX   '; nbytes : 3; adrmode : dirdata),
(name : 'MOV @R0,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV @R1,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R0,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R1,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R2,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R3,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R4,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R5,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R6,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'MOV  R7,#XX    '; nbytes : 2; adrmode : data8  ),
{80-8f}
(name : 'SJMP  XX       '; nbytes : 2; adrmode : rel    ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'ANL   C, XX    '; nbytes : 2; adrmode : bit10  ),
(name : 'MOVC  A,@A+PC  '; nbytes : 1; adrmode : none   ),
(name : 'DIV   AB       '; nbytes : 1; adrmode : none   ),
(name : 'MOV   XX, XX   '; nbytes : 3; adrmode : dirdir ),
(name : 'MOV   XX, @R0  '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, @R1  '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R0   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R1   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R2   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R3   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R4   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R5   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R6   '; nbytes : 2; adrmode : predir ),
(name : 'MOV   XX, R7   '; nbytes : 2; adrmode : predir ),
{90-9f}
(name : 'MOV DPTR,#XXXX '; nbytes : 3; adrmode : data16 ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'MOV   XX, C    '; nbytes : 2; adrmode : bit7   ),
(name : 'MOVC  A,@A+DPTR'; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A,#XX    '; nbytes : 2; adrmode : data8  ),
(name : 'SUBB  A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'SUBB  A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'SUBB  A, R7    '; nbytes : 1; adrmode : none   ),
{a0-af}
(name : 'ORL   C, XX    '; nbytes : 2; adrmode : bit10  ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'MOV   C, XX    '; nbytes : 2; adrmode : bit10  ),
(name : 'INC   DPTR     '; nbytes : 1; adrmode : none   ),
(name : 'MUL   AB       '; nbytes : 1; adrmode : none   ),
(name : '               '; nbytes : 1; adrmode : none   ),
(name : 'MOV  @R0,XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  @R1,XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R0, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R1, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R2, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R3, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R4, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R5, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R6, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV  R7, XX    '; nbytes : 2; adrmode : dir10  ),
{b0-bf}
(name : 'ANL  C,/XX     '; nbytes : 2; adrmode : bit10  ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'CPL   XX       '; nbytes : 2; adrmode : bit7   ),
(name : 'CPL   C        '; nbytes : 1; adrmode : none   ),
(name : 'CJNE  A, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE  A,  XX,XX'; nbytes : 3; adrmode : dirrel ),
(name : 'CJNE @R0,#XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE @R1,#XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R0, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R1, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R2, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R3, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R4, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R5, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R6, #XX,XX'; nbytes : 3; adrmode : datarel),
(name : 'CJNE R7, #XX,XX'; nbytes : 3; adrmode : datarel),
{c0-cf}
(name : 'PUSH  XX       '; nbytes : 2; adrmode : dir7   ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'CLR   XX       '; nbytes : 2; adrmode : bit7   ),
(name : 'CLR   C        '; nbytes : 1; adrmode : none   ),
(name : 'SWAP  A        '; nbytes : 2; adrmode : none   ),
(name : 'XCH   A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'XCH   A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'XCH   A, R7    '; nbytes : 1; adrmode : none   ),
{d0-df}
(name : 'POP   XX       '; nbytes : 2; adrmode : dir7   ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'SETB  XX       '; nbytes : 2; adrmode : bit7   ),
(name : 'SETB  C        '; nbytes : 1; adrmode : none   ),
(name : 'DA    A        '; nbytes : 2; adrmode : none   ),
(name : 'DJNZ  XX,XX    '; nbytes : 3; adrmode : dirrel7),
(name : 'XCHD  A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'XCHD  A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'DJNZ  R0,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R1,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R2,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R3,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R4,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R5,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R6,XX    '; nbytes : 2; adrmode : rel10  ),
(name : 'DJNZ  R7,XX    '; nbytes : 2; adrmode : rel10  ),
{e0-ef}
(name : 'MOVX  A, @DPTR '; nbytes : 1; adrmode : none   ),
(name : 'AJMP  XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'MOVX  A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'MOVX  A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'CLR   A        '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, XX    '; nbytes : 2; adrmode : dir10  ),
(name : 'MOV   A, @R0   '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, @R1   '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R0    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R1    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R2    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R3    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R4    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R5    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R6    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   A, R7    '; nbytes : 1; adrmode : none   ),
{f0-ff}
(name : 'MOVX  @DPTR, A '; nbytes : 2; adrmode : none   ),
(name : 'ACALL XXXX     '; nbytes : 2; adrmode : addr11 ),
(name : 'MOVX  @R0, A   '; nbytes : 1; adrmode : none   ),
(name : 'MOVX  @R1, A   '; nbytes : 1; adrmode : none   ),
(name : 'CPL   A        '; nbytes : 1; adrmode : none   ),
(name : 'MOV   XX, A    '; nbytes : 2; adrmode : predir ),
(name : 'MOV  @R0, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV  @R1, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R0, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R1, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R2, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R3, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R4, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R5, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R6, A    '; nbytes : 1; adrmode : none   ),
(name : 'MOV   R7, A    '; nbytes : 1; adrmode : none   ));

   CommandSet = [cmDownLoad, cmUpLoad, cmRegisters, cmXdata, cmIdata, cmAssembly,
          cmSFR, cmPorts, cmCalc, cmDos, cmHaltPC, cmRunPC, cmViewFile, cmChDir,
          cmEdit, cmGoPCAdr, cmReset, cmTracePC, cmNext, cmZoom, cmTerminal];

var
   recbuffer : array[1..bufflimit] of byte;
   inptr     : integer;
   outptr    : integer;
   oldcom1, oldcom2 : pointer;
   lecho            : localecho;
   acia             : array[comports] of word;  {holds addresses of com1/com2}
   currentport      : comports;                 { 0 = com1, 1 = com2 }
   comportinfo      : array[comports] of cominfo;
   com1inst, com2inst : boolean;
   Ticks     : word;
   Running80C552, RunningTerminal, Save552State : Boolean;
   Demo       : TermWin;
   Interior   : MyTerm;
   monitor    : mon;
   pmonitor   : ^mon;
   R          : trect;
   pdat, idat, xdat, rdat, asmdat, sfrdat : trect;
   pwin, iwin, xwin, rwin, asmwin, sfrwin : scrwindow;

procedure newcom; interrupt;
var ch : byte;
begin
   {read byte from receive buffer, deposit into buffer}
   ch := port[acia[currentport]+RBR];
   recbuffer[inptr] := ch;
   inptr := inptr + 1;
   if inptr > bufflimit then inptr := 1;
   Port[PICCtrl] := EOI;   { reset PIC }
end;

procedure deinstallrs232( portnum : ComPorts );
var ch    : byte;
begin
   ch := Port[PICMask];      {read PIC interrupt mask setting }
   case portnum of
      Com1 : begin
                ch := ch OR $10;   { disable interrupt irq 4 on PIC }
                port[PICMask] := ch;
                port[acia[Com1]+IER] := DISINT;
                port[acia[Com1]+MCR] := 0;
                if Com1Inst then begin
                  SetIntVec( com1int, oldcom1 );
                  Com1Inst := False;
               end;
             end;
      Com2 : begin
                ch := ch OR $08;
                port[PICMask] := ch;
                port[acia[Com2]+IER] := DISINT;
                port[acia[Com2]+MCR] := 0;
                if Com2Inst then begin
                   SetIntVec( com2int, oldcom2 );
                   Com2Inst := False;
                end;
             end
      else begin
           write(char($07));
           MessageBox('Invalid comport', nil, mfError+mfOkButton);
      end;
   end;
end;

procedure Initcomport( ComPort : ComPorts; BaudRate : BaudRates;
  DataBit : DataBits; Parity : ParityBits; Stops : StopBits );
var  ch, dl, dh, format : byte;
begin
   port[acia[comport]+LCR] := ABRG;
   case baudrate of
       b1200 : begin dh := 1; dl := $60; end;
       b2400 : begin dh := 0; dl := $30; end;
       b4800 : begin dh := 0; dl := $18; end;
       b9600 : begin dh := 0; dl := $0c; end;
       else begin
          write(char($07));
          MessageBox('Illegal baudrate', nil, mfError + mfOkButton);
       end;
   end;
   port[acia[comport]+DLL] := dl;
   port[acia[comport]+DLH] := dh;
   case Parity of
     NoParity : format := 0;
     Odd      : format := $28;
     Even     : format := $38;
     else begin
          write(char($07));
          MessageBox('Illegal parity format', nil, mfError + mfOkButton);
       end;
   end;
   if stops = two then format := format or $04;
   case DataBit of
     eight : format := format or $03;
     seven : format := format or $02;
     else begin
         write(char($07));
         MessageBox('Illegal number of stops', nil, mfError + mfOkButton);
     end;
   end;
   port[acia[comport]+LCR] := format;
   case comport of
      Com1 : begin
             if NOT Com1Inst then begin
                if Com2Inst then DeInstallrs232( Com2 );
                GetIntVec( com1int, oldcom1 );
                SetIntVec( com1int, @newcom );
                Com1Inst := true;
             end;
          end;
      Com2 : begin
             if NOT Com2Inst then begin
                if Com1Inst then DeInstallrs232( Com1 );
                GetIntVec( com2int, oldcom2 );
                SetIntVec( com2int, @newcom );
                Com2Inst := true;
             end;
          end;
   end;
   port[acia[comport]+MCR] := $0b;
   port[acia[comport]+IER] := 1;
   ch := Port[PICMask];       {read PIC interrupt mask setting }
   case comport of
      Com1 : ch := ch AND $ef;   { enable interrupt irq 4 on PIC }
      Com2 : ch := ch AND $f7;
   end;
   port[PICMask] := ch;
   inptr  := 1;
   outptr := 1;
   ch     := port[acia[comport]+RBR];  {dummy read to clear RBR }
end;

procedure putch( ch : byte );
begin
   while (port[acia[currentport]+LSR] AND THRE) = 0 do
       ;
   port[acia[currentport]+THR] := ch;
end;

function getch : byte;
var  ch   : byte;
     wait : word;
begin
     wait := $0000;
     while (outptr = inptr) AND (wait < $8000) do
           wait := wait + 1;
     if wait >= $8000 then begin
        write(char($07));
        if MessageBox('Error. Reset Target',nil,mfError+mfOkButton) = cmCancel then
           {shut down application}
           {Message(PMonitor, evCommand, cmQuit, nil)}
        else ch := 0;
     end
     else begin
        ch := recbuffer[outptr];
        outptr := outptr + 1;
        if outptr > bufflimit then outptr := 1;
     end;
     getch := ch;
end;

function send( action : string ) : string;
var buff : string;
    lp   : integer;
    ch   : byte;
begin
    for lp := 1 to length( action ) do
        putch( byte(action[lp]) );
    putch( CR );
    buff := '';
    ch := getch;
    while ch <> CR do begin
       buff := buff + char(ch);
       ch   := getch;
    end;
    send := buff;
end;

function integertostring( item : integer ) : string;
var st : string;
    di, num : integer;
begin
   { convert integer to two byte hex string with leading zero }
   di := 0;
   num := item;
   st := '';
   while num > 15 do begin
      st  := st + hexdigits[num DIV 16];
      num := num MOD 16;
   end;
   st := st + hexdigits[num];
   while length(st) < 2 do st := '0' + st;
   integertostring := st
end;

function wordtostring( item : word ) : string;
var st : string;
begin
   { convert word to four byte hex string with leading zeros }
   st := integertostring( item SHR 8 );
   st := st + integertostring( item AND $00ff );
   wordtostring := st
end;

function strtobin( by : string ) : string;
var bin : string;
begin
   { convert by to binary string of 8 of 01 }
   { by input is 2 characters long }
   bin := '';
   if by[1] in ['A'..'F'] then
      bin := binvalues[(ord(by[1]) - $37)]
   else
      bin := binvalues[ord(by[1]) - $30];
   if by[2] in ['A'..'F'] then
      bin := bin + binvalues[(ord(by[2]) - $37)]
   else
      bin := bin + binvalues[ord(by[2]) - $30];
   strtobin := bin;
end;

function strtointeger( by : string ) : integer;
var num : integer;
begin
   {two hex bytes to convert}
   while length(by) < 2 do
      by := '0' + by;
   if by[1] in ['A'..'F'] then
      num := (ord(by[1]) - $37) * 16
   else
      num := ((ord(by[1]) - $30) * 16);
   if by[2] in ['A'..'F'] then
      num := num + (ord(by[2]) - $37)
   else
      num := num + (ord(by[2]) - $30);
   strtointeger := num;
end;

function strtoword( by : string ) : word;
var num : word;
begin
   {four hex bytes to convert}
   while length(by) < 4 do
      by := '0' + by;
   num := 0;
   if by[1] in ['A'..'F'] then
      num := num + (ord(by[1]) - $37) * 16 * 16 * 16
   else
      num := num + ((ord(by[1]) - $30) * 16 * 16 * 16);
   if by[2] in ['A'..'F'] then
      num := num + ((ord(by[2]) - $37) * 16 * 16)
   else
      num := num + ((ord(by[2]) - $30) * 16 * 16);
   if by[3] in ['A'..'F'] then
      num := num + (ord(by[3]) - $37) * 16
   else
      num := num + ((ord(by[3]) - $30) * 16);
   if by[4] in ['A'..'F'] then
      num := num + (ord(by[4]) - $37)
   else
      num := num + (ord(by[4]) - $30);
   strtoword := num;
end;

function strtoascii( by : string ) : string;
var num, len : integer;
    st : string;
begin
   st := '';
   len := 1;
   while len < length(by) do begin
      num := strtointeger( by[len]+by[len+1] );
      if ord(num) in [32..127] then
         st := st + chr(ord(num))
      else
         st := st + '.';
      len := len + 2;
   end;
   strtoascii := st;
end;

procedure StrUpper( var st : string );
var  len, loop : integer;
     ch : byte;
begin
   len := length(st);
   for loop := 1 to len do
      if st[loop] in ['a'..'z'] then
         st[loop] := chr(ord(st[loop]) - ord('a') + ord('A'));
end;

function ValidHexStr( HexStr : String ) : Boolean;
var digit : integer;
    result: boolean;
begin
    result := true;
    for digit := 1 to length(HexStr) do
       if NOT (HexStr[digit] in ['0'..'9','A'..'F','a'..'f']) then
          result := false;
    ValidHexStr := result;
end;

procedure UpdateWindows;
begin
     {broadcast event for all windows to update themselves}
     Message( rwin, evBroadcast, cmScrollBarChanged, nil );
     Message( xwin, evBroadcast, cmScrollBarChanged, nil );
     Message( pwin, evBroadcast, cmScrollBarChanged, nil );
     Message( iwin, evBroadcast, cmScrollBarChanged, nil );
     Message( sfrwin, evBroadcast, cmScrollBarChanged, nil );
     Message( asmwin, evBroadcast, cmScrollBarChanged, nil );
end;

function calcmotorolachksum( line : string ) : string;
var num, total, loop : integer;
    temp : string;
begin
    loop  := 1;
    total := 0;
    while loop < length(line) do begin
       temp  := line[loop] + line[loop+1];
       total := total + strtointeger( temp );
       loop := loop + 2;
    end;
    total := 255 - (total AND $00ff);
    calcmotorolachksum := integertostring(total);
end;

function calcintelchksum( line : string ) : string;
var num, total, loop : integer;
    temp : string;
begin
    loop  := 1;
    total := 0;
    while loop < length(line) do begin
       temp  := line[loop] + line[loop+1];
       total := total + strtointeger( temp );
       loop := loop + 2;
    end;
    total := 256 - (total MOD 256);
    calcintelchksum := integertostring(total);
end;

function FileExists(FileName: string) : Boolean;
{ Returns True if file exists; otherwise, it returns False.
  Closes the file if it exists. }
var  f: file;
begin
  {$I-}
  Assign(f, FileName);
  Reset(f);
  Close(f);
  {$I+}
  FileExists := (IOResult = 0) and
   (FileName <> '');
end;  { FileExists }

{ 552 >> file }
procedure writeintelrecord( var txtfile : text; rectype : string; addr : word; data : string );
var  checksum : string;
     line     : string;
     loadadr  : string;
     reclen   : string;
begin
     line := '';
     loadadr := wordtostring(addr);
     reclen  := integertostring(length(data) DIV 2);
     line    := reclen + loadadr + rectype + data;
     checksum:= calcintelchksum( line );
     writeln(txtfile, ':'+line+checksum);
end;

{ 552 >> file }
procedure writemotorolarecord( var txtfile : text; rectype : string; addr : word; data : string );
var  checksum : string;
     line     : string;
     loadadr  : string;
     reclen   : string;
begin
     {s1,msb/lsb-of-datalen, loadadr(4msbfirst), databytes}
     line := '';
     loadadr := wordtostring(addr);
     reclen  := integertostring((length(data) DIV 2) + 3);
     line    := reclen + loadadr + data;
     checksum:= calcmotorolachksum( line );
     writeln(txtfile, rectype + line+checksum);
end;

{ 552 >> file }
procedure WriteFile( Filename : String; startaddr, endaddr : Word; FType : FileType );
var line          : string;
    loop          : word;
    txtfile       : text;
    length        : word;   { number of bytes to dump       }
begin
    assign( txtfile, Filename );
    ReWrite( txtfile );
    length := startaddr;
    while length < endaddr do begin
        line := '';
        for loop := 0 to 15 do
            line := line + send('x '+wordtostring(length+loop));
        case FType of
           Intel    : writeintelrecord( txtfile, '00', length, line );
           Motorola : writemotorolarecord(txtfile,'S1',length, line );
        end;
        length := length + 16;
     end;
     case FType of
        Intel   : writeintelrecord( txtfile, '01', startaddr, '');
        Motorola: writemotorolarecord(txtfile,'S9',startaddr, '');
     end;
     Close( txtfile );
end;

{ 552 >> file }
function UpLoadFile( Filename, startaddr, endaddr : String; FType : FileType ) : Boolean;
var OverWrite     : Boolean;
begin
    OverWrite := True;
    if fileexists( FileName ) then begin
       write(char($07));
       if MessageBox('File Exists. OVERWRITE? ', nil, mfWarning + mfOkCancel) = cmCancel then
           OverWrite := False
    end;
    {verify startaddr and endaddr by converting to word and range check}
    if strtoword(endaddr) < strtoword(startaddr) then begin
       write(char($07));
       MessageBox('End Address < Start Address', nil, mfError + mfOkButton)
    end
    else if strtoword(startaddr) < $8000 then begin
       write(char($07));
       MessageBox('Start Address < $8000', nil, mfError + mfOkButton)
    end
    else begin
       if OverWrite = true then begin
           Writefile( FileName, strtoword(startaddr), strtoword(endaddr), FType );
           UpLoadFile := True;
       end
       else begin
           write(char($07));
           MessageBox('File not uploaded', nil, mfWarning + mfOkButton);
           UpLoadFile := False;
       end;
    end;
end;

function InvalidIntelLine(line:string) : Boolean;
var total, loop:integer;
    datastr    : string;
    mychksum   : string;
    filechksum : string;
begin
    total := length(line);
    filechksum := line[total-1]+line[total];
    datastr := '';
    for loop := 2 to total - 2 do            {get past :}
        datastr := datastr + line[loop];
    mychksum := calcintelchksum(datastr);
    if mychksum <> filechksum then
       InvalidIntelLine := True
    else InvalidIntelLine := False
end;

function InvalidMotorolaLine(line:string) : Boolean;
var total, loop:integer;
    datastr    : string;
    mychksum   : string;
    filechksum : string;
begin
    total := length(line);
    filechksum := line[total-1]+line[total];
    datastr := '';
    for loop := 3 to total - 2 do           {get past s1}
        datastr := datastr + line[loop];
    mychksum := calcmotorolachksum(datastr);
    if mychksum <> filechksum then
       InvalidMotorolaLine := True
    else InvalidMotorolaLine := False
end;

{file >> 552}
function ProcessIntelLine(line:string) : Boolean;
var Reclen  : Integer;
    Loadadr : Word;
    RecType : Integer;
    CheckSum: Integer;
    Loop    : Integer;
    Temp    : String;
begin
    if line[1] <> ':' then begin
        write(char($07));
        MessageBox('File is not INTEL HEX format', nil, mfError + mfOkButton);
        ProcessIntelLine := False;
    end
    else begin
       if length(line) < 11 then begin
          write(char($07));
          MessageBox('Invalid line (too short)', nil, mfError + mfOkButton);
          ProcessIntelLine := False;
       end
       else begin
          if InvalidIntelLine(Line) then begin
             write(char($07));
             MessageBox('Invalid checksum', nil, mfError + mfOkButton);
             ProcessIntelLine := False;
          end
          else begin
             RecLen  := StrToInteger(line[2]+line[3]);
             Loadadr := StrToWord(line[4]+line[5]+line[6]+line[7]);
             RecType := StrToInteger(Line[8]+line[9]);
             Case RecType of
                 00 : begin {data record}
                          Loop := 0;
                          while Loop < (RecLen*2) do begin
                             Temp := 'X '+ WordtoString(Loadadr+(Loop DIV 2)) + ' ' + Line[10+Loop] + Line[11+Loop];
                             Send(Temp);
                             Loop := Loop + 2;
                          end;
                          ProcessIntelLine := true;
                       end;
                 01 :  begin
                           { send('P 8076' );}  {WordtoString(LoadAdr)}
                           ProcessIntelLine := True;
                       end;
                 else  begin
                          write(char($07));
                          MessageBox('Unknown record type',nil,mfError+mfOkButton);
                          ProcessIntelLine := False;
                       end;
             end;
          end;
       end;
    end;
end;

{file >> 552}
function ProcessMotorolaLine(line:string) : Boolean;
var Reclen  : Integer;
    Loadadr : Word;
    RecType : Integer;
    CheckSum: Integer;
    Loop    : Integer;
    Temp    : String;
begin
    if (line[1] <> 'S') AND (line[1] <> 's') then begin
        write(char($07));
        MessageBox('File is not Motorola S format', nil, mfError + mfOkButton);
        ProcessMotorolaLine := False;
    end
    else begin
       if length(line) < 10 then begin
          write(char($07));
          MessageBox('Invalid line (too short)', nil, mfError + mfOkButton);
          ProcessMotorolaLine := False;
       end
       else begin
          if InvalidMotorolaLine(Line) then begin
             write(char($07));
             MessageBox('Invalid checksum', nil, mfError + mfOkButton);
             ProcessMotorolaLine := False;
          end
          else begin
             RecLen  := StrToInteger(line[3]+line[4]);
             Loadadr := StrToWord(line[5]+line[6]+line[7]+line[8]);
             RecType := StrToInteger(Line[2]);
             Case RecType of
                 1  : begin {data record}
                          Loop := 0;
                          while Loop < (RecLen*2) do begin
                             Temp := 'X '+ WordtoString(Loadadr+(Loop DIV 2)) + ' ' + Line[9+Loop] + Line[10+Loop];
                             Send(Temp);
                             Loop := Loop + 2;
                          end;
                          ProcessMotorolaLine := true;
                       end;
                 9  :  begin
                           { send('P 8076' );}  {WordtoString(LoadAdr)}
                           ProcessMotorolaLine := True;
                       end;
                 else  begin
                          write(char($07));
                          MessageBox('Unknown record type',nil,mfError+mfOkButton);
                          ProcessMotorolaLine := False;
                       end;
             end;
          end;
       end;
    end;
end;

{file >> 552}
procedure DownLoadFile( FileName, Start, EndAddr : String; FType : FileType );
var line    : string;
    txtfile : text;
    Okay    : Boolean;
begin
    Okay := true;
    assign( txtfile, FileName );
    if fileexists( FileName ) = false then begin
        write(char($07));
        MessageBox('File does not exist', nil, mfError + mfOkButton)
    end
    else begin
        reset( txtfile );
        line := '';
        while (not eof(txtfile)) and (okay) do begin
            readln( txtfile, line );
            Case FType of
               Intel    : Okay := ProcessIntelLine(Line);
               Motorola : Okay := ProcessMotorolaLine(Line);
            end;
        end;
        Close(txtfile);
    end;
    Message( rwin,   evBroadcast, cmScrollBarChanged, nil );
    Message( xwin,   evBroadcast, cmScrollBarChanged, nil );
    Message( asmwin, evBroadcast, cmScrollBarChanged, nil );
end;

procedure Transfer( CmdType : Integer );
var FDialog : PDialog;
    R       : TRect;
    FInfo   : FileInfo;
    Control : Word;
    Title   : String;
    FileName: String;
    StartAdr: String;
    EndAdr  : String;
    Ftype   : FileType;
begin
    FType := Intel;
    R.Assign(22,8,62,18);
    if cmdType = FILEUP then
       Title := 'Upload file from 552'
    else
       Title := 'Download file to 552';
    FDialog := New(PDialog, Init(R, Title ));
    with FDialog^ do begin
        if CmdType = FILEUP then begin
            R.Assign(17,3,23,4);
            FInfo.StartAdr := New(PInputLine, Init(R, 4));
            Insert(FInfo.StartAdr);
            R.Assign(1,3,15,4);
            FInfo.FStart := New(PLabel, Init(R,'~S~tart Address', Finfo.StartAdr));
            Insert(FInfo.FStart );
            R.Assign(17,5,23,6);
            FInfo.EndAdr := New(PInputLine, Init(R, 4));
            Insert(FInfo.EndAdr);
            R.Assign(1,5,15,6);
            FInfo.FEnd := New(PLabel, Init(R,'~E~nd Address', Finfo.EndAdr));
            Insert(FInfo.FEnd );
        end;
        R.Assign(3,7,9,9);
        Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
        R.Assign(10,7,22,9);
        Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
        R.Assign(25,3,38,5);
        SelectNext(False);
        Case CmdType of
            FILEUP : Begin
                        FInfo.FType := New(PRadioButtons, Init(R,
                        NewSItem('~I~ntel',
                        NewSItem('~M~otorola', nil))));
                      end;
            FILEDN :  Begin
                        FInfo.FType := New(PRadioButtons, Init(R,
                        NewSItem('~I~ntel',
                        NewSItem('~M~otorola', nil))));
                      end;
        end;
        Insert(FInfo.FType);
        R.Assign(25,2,35,3);
        Insert(New(PLabel, Init(R, 'File Type', nil)));
        R.Assign(11,1,23,2);
        FInfo.Name := New(PInputLine, Init(R, 22));
        Insert(FInfo.Name);
        R.Assign(1,1,10,2);
        FInfo.FName := New(PLabel, Init(R,'~F~ilename', FInfo.Name));
        Insert(FInfo.FName );
    end;
    Control := Desktop^.ExecView(FDialog);
    if Control = cmOk then begin
       Finfo.Name^.GetData(Filename);
       FInfo.FType^.GetData(FType);
       if CmdType = FILEUP then begin
          FInfo.StartAdr^.GetData(StartAdr);
          FInfo.EndAdr^.GetData(EndAdr);
       end;
       StrUpper(FileName);
       StrUpper(StartAdr);
       StrUpper(EndAdr);
       if FileName <> '' then begin
           case CmdType of
                FILEDN : DownLoadFile(FileName, StartAdr, EndAdr, FType);
                FILEUP : UpLoadFile(FileName, StartAdr, EndAdr, FType);
           end;
       end
       else begin
          write(char($07));
          MessageBox('No File Name specified', nil, mfError + mfOkButton);
       end;
    end;
    Dispose(FDialog, Done);
end;

procedure GotoDos( Cmdstr : String );
var Dosstr    : String;
    ErrorCode : Integer;
begin
     DoneSysError;
     DoneEvents;
     DoneVideo;
     DoneMemory;
     SetMemTop(HeapPtr);
     printstr('Type EXIT to return');
     DeInstallRs232(currentport);
     SwapVectors;
     Exec( GetEnv('COMSPEC'), cmdstr );
     ErrorCode := DosError;
     SwapVectors;
     Initcomport( currentport, comportinfo[currentport].baud,
          comportinfo[currentport].data, comportinfo[currentport].parity,
          comportinfo[currentport].stop );
     SetMemTop(HeapEnd);
     InitMemory;
     InitVideo;
     InitEvents;
     InitSysError;
     DeskTop^.ReDraw;
     if ErrorCode <> 0 then begin
         write(char($07));
         Case ErrorCode of
              2: MessageBox('File not Found',     nil,mfError + mfOKButton);
              3: MessageBox('Path not Found',     nil,mfError + mfOKButton);
              5: MessageBox('Access Denied',      nil,mfError + mfOKButton);
              6: MessageBox('Invalid Handle',     nil,mfError + mfOKButton);
              8: MessageBox('Not enough memory',  nil,mfError + mfOKButton);
             10: MessageBox('Invalid environment',nil,mfError + mfOKButton);
             11: MessageBox('Invalid format',     nil,mfError + mfOKButton);
             18: MessageBox('No more files',      nil,mfError + mfOKButton);
             else MessageBox('Unknown Error',nil,mfError + mfOkButton);
         end;
     end;
end;

{ a terminal, main use is to talk directly to the chip, and useful also for }
{ when user takes over rs232 interrupt. 1-user halts processor, 2-downloads }
{ code, 3-sets pc value in register window, 4-selects terminal, 5-types     }
{ G followed by CR<enter>                                                   }
procedure Termrs232;
begin
  { Initialize the terminal window object }
  R.Assign(0,0,80,23);
  Demo := New(TermWin, init(R,'Terminal', wnNoNumber, Interior, 2048));
  Desktop^.Insert(Demo);
  Interior^.ScrollTo(0, 0);
  Interior^.DisableCommands(CommandSet);
end;

procedure TermOpts;
var TermDialog : PDialog;
    R       : TRect;
    Control : Word;
    ComInfo : ComPortControl;
    BaudRate : BaudRates;
    Stops    : StopBits;
    DataBit  : Databits;
    Parity   : ParityBits;
begin
    if RunningTerminal then
    begin
        R.Assign(22,8,62,20);
        TermDialog := New(PDialog, Init(R, 'Terminal Options'));
        with TermDialog^ do begin
           R.Assign(2,1,12,2);
           Insert(New(PLabel, Init(R,'Port',nil)));
           R.Assign(2,2,12,4);
           Insert(New(PRadioButtons, Init(R,
              NewSItem('~A~Com1',
              NewSitem('~B~Com2', nil)))));
           R.Assign(14,1,24,2);
           Insert(New(PLabel, Init(R,'Duplex',nil)));
           R.Assign(14,2,24,4);
           Insert(New(PRadioButtons, Init(R,
              NewSItem('~F~ull',
              NewSitem('~H~alf', nil)))));
           R.Assign(26,1,38,2);
           Insert(New(PLabel, Init(R,'Baud Rate',nil)));
           R.Assign(26,2,38,6);
           Insert(New(PRadioButtons, Init(R,
              NewSItem('~1~200',
              NewSItem('~2~400',
              NewSItem('~4~800',
              NewSItem('~9~600', nil)))))));
           {stop(12), data(78), parity (OEN) in that order}
           R.Assign(2,5,12,6);
           Insert(New(PLabel, Init(R,'Stops',nil)));
           R.Assign(2,6,12,8);
           Insert(New(PRadioButtons, Init(R,
              NewSItem('~S~1',
              NewSitem('~T~2', nil)))));
           R.Assign(14,5,24,6);
           Insert(New(PLabel, Init(R,'DataBits',nil)));
           R.Assign(14,6,24,8);
           Insert(New(PRadioButtons, Init(R,
              NewSItem('~7~',
              NewSitem('~8~', nil)))));
           R.Assign(26,7,38,8);
           Insert(New(PLabel, Init(R,'Parity',nil)));
           R.Assign(26,8,38,11);
           Insert(New(PRadioButtons, Init(R,
              NewSItem('o~D~D',
              NewSItem('~E~ven',
              NewSItem('~N~one', nil))))));
           R.Assign(3,9,9,11);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,9,22,11);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           SelectNext(False);
       end;
       {prepare the data record for current options}
       case CurrentPort of
         Com1 : ComInfo.Port := 0;
         Com2 : ComInfo.Port := 1;
       end;
       case comportinfo[currentport].echo of
         halfduplex : ComInfo.Echo := 1;
         fullduplex : ComInfo.Echo := 0;
       end;
       case comportinfo[currentport].Baud of
         b1200 : ComInfo.Baud := 0;
         b2400 : ComInfo.Baud := 1;
         b4800 : ComInfo.Baud := 2;
         b9600 : ComInfo.Baud := 3;
       end;
       case comportinfo[currentport].stop of
         one : ComInfo.Stop := 0;
         two : ComInfo.Stop := 1;
       end;
       case comportinfo[currentport].Data of
         seven : ComInfo.Data := 0;
         eight : ComInfo.Data := 1;
       end;
       case comportinfo[currentport].Parity of
         Odd      : ComInfo.Parity := 0;
         Even     : ComInfo.Parity := 1;
         NoParity : ComInfo.Parity := 2;
       end;
       TermDialog^.SetData(ComInfo);
       Control := Desktop^.ExecView(TermDialog);
       if Control = cmOk then begin
         TermDialog^.GetData(ComInfo);
         if ComInfo.Echo = 0 then lecho := fullduplex else lecho := halfduplex;
         if ComInfo.Port = 0 then Currentport := Com1 else Currentport := Com2;
         case ComInfo.Baud of
            0 : BaudRate := b1200;
            1 : BaudRate := b2400;
            2 : BaudRate := b4800;
            3 : BaudRate := b9600;
            else BaudRate := b9600;
         end;
         if ComInfo.Stop = 0 then Stops := One else Stops := Two;
         If ComInfo.Data = 0 then DataBit := Seven else DataBit := Eight;
         Case ComInfo.Parity of
            0 : Parity := Odd;
            1 : Parity := Even;
            2 : Parity := NoParity;
            else Parity := NoParity;
         end;
         initcomport( CurrentPort, BaudRate, DataBit, Parity, Stops );
         comportinfo[currentport].echo := lecho;
         comportinfo[currentport].baud := BaudRate;
         comportinfo[currentport].stop := Stops;
         comportinfo[currentport].data := DataBit;
         comportinfo[currentport].parity:= Parity;
       end;
       Dispose(TermDialog, Done);
    end
    else
    begin
       write(char($07));
       MessageBox('Only available in terminal mode',nil, mfError+mfOkButton);
    end;
end;

procedure RunPCAtAddress;
var  CmdResult, MemAdr : string;
     MDialog : PDialog;
     R       : TRect;
     Control : Word;
     StartAdr: PInputLine;
begin
     R.Assign(30,8,55,15);
     MDialog := New(PDialog, Init(R, 'RUN PC' ));
     with MDialog^ do begin
        R.Assign(3,4,9,6);
        Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
        R.Assign(10,4,22,6);
        Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
        R.Assign(17,2,23,3);
        StartAdr := New(PInputLine, Init(R, 4));
        Insert(StartAdr);
        R.Assign(1,2,15,3);
        Insert( New(PLabel, Init(R,'~P~C Address', StartAdr)));
     end;
     Control := Desktop^.ExecView(MDialog);
     if Control = cmOk then
     begin
        MDialog^.GetData(MemAdr);
        if (strtoword(MemAdr) < $8000) OR (strtoword(MemAdr) > $fe00) then begin
           write(char($07));
           MessageBox('Memory Address out of range',nil,mfError+mfOkButton);
        end
        else {send a run command, activate register window to foreground}
           CmdResult := send('g '+MemAdr);
        {broadcast event for all windows to update themselves}
        UpdateWindows;
        Running80C552 := True;
     end;
     Dispose(MDialog, Done);
end;

procedure ResetPC;
var  CmdResult : string;
     Temp : Byte;
begin
    write(char($07));
    if MessageBox('Reset Target! Are you sure?',nil,mfWarning+mfOkCancel) = cmOk then begin
        CmdResult := send('g 0000');
        Temp := Getch;
        Temp := GetCh;
        Running80C552 := True;
    end;
    UpDateWindows;
end;

procedure RunPC;
var  CmdResult : string;
begin
     Running80C552 := True;
     CmdResult := send('G');
     UpDateWindows;
end;

procedure HaltPC;
var  CmdResult : string;
begin
     Running80C552 := false;
     CmdResult := send('H');
     UpDateWindows;
end;

procedure TracePC;
var  CmdResult : string;
     Temp : Byte;
begin
     CmdResult := send('T');
     Temp := Getch;
     UpDateWindows;
end;

function DecodeInstruction( CmdLine : String; InstrPtr : Integer ) : String;
var  Instruction : String;
     OPByte      : Integer;
begin
   OpByte := StrtoInteger(CmdLine[InstrPtr] + CmdLine[InstrPtr+1]);
   Instruction := Instrs[OpByte].Name;
   {add and replace XX's where appropriate }
   case Instrs[OpByte].adrmode of
      bit7, dir7, rel, predir : begin
                             Instruction[7] := CmdLine[Instrptr+2];
                             Instruction[8] := CmdLine[InstrPtr+3];
                          end;
      addr11, addr16    : begin
                             Instruction[7] := CmdLine[Instrptr+2];
                             Instruction[8] := CmdLine[InstrPtr+3];
                             Instruction[9] := CmdLine[Instrptr+4];
                             Instruction[10]:= CmdLine[InstrPtr+5];
                          end;
      dir10, data8, rel10, bit10 : begin
                             Instruction[10] := CmdLine[Instrptr+2];
                             Instruction[11] := CmdLine[InstrPtr+3];
                          end;
      bitrel, dirdata, dirdir : begin
                             Instruction[7]  := CmdLine[Instrptr+2];
                             Instruction[8]  := CmdLine[InstrPtr+3];
                             Instruction[11] := CmdLine[Instrptr+4];
                             Instruction[12] := CmdLine[InstrPtr+5];
                          end;
      datarel, dirrel :   begin
                             Instruction[11] := CmdLine[Instrptr+2];
                             Instruction[12] := CmdLine[InstrPtr+3];
                             Instruction[14] := CmdLine[Instrptr+4];
                             Instruction[15] := CmdLine[InstrPtr+5];
                          end;
      dirrel7 :           begin
                             Instruction[7]  := CmdLine[Instrptr+2];
                             Instruction[8]  := CmdLine[InstrPtr+3];
                             Instruction[10] := CmdLine[Instrptr+4];
                             Instruction[11] := CmdLine[InstrPtr+5];
                          end;
      data16 :            begin
                             Instruction[11] := CmdLine[Instrptr+2];
                             Instruction[12] := CmdLine[InstrPtr+3];
                             Instruction[13] := CmdLine[Instrptr+4];
                             Instruction[14] := CmdLine[InstrPtr+5];
                          end;
   end;
   DecodeInstruction := Instruction;
end;

function DoEditDialog( Dialog : Integer; Info : Pointer ) : Word; far;
var R : Trect;
    T : Tpoint;
begin
    case Dialog of
       edOutOfMemory :
          doEditDialog := MessageBox('Not enough memory.', nil, mfError+mfOkButton);
       edReadError:
          DoEditDialog := MessageBox('Error reading file %s.',@info, mfError+mfOkButton);
       edWriteError:
          DoEditDialog := MessageBox('Error writing file %s.',@info, mfError+mfOkButton);
       edCreateError:
          DoEditDialog := MessageBox('Error creating file %s.',@info, mfError+mfOkButton);
       edSaveModify:
          DoEditDialog := MessageBox('%s has been modified. Save?',@info, mfInformation+mfYesNoCancel);
    end;
end;

procedure MonEditor;
var  FDialog : PDialog;
     FName   : PView;
     Control : Word;
     Editor  : PView;
     R       : TRect;
     FileName: String[22];
begin
   R.Assign(30,8,55,11);
   FDialog := New(PDialog, Init(R, 'FileName? '));
   with FDialog^ do begin
      R.Assign(1,1,24,2);
      FName := New(PInputLine( Init(R,22));
      Insert(FName);
   end;
   Control := DeskTop^.ExecView(FDialog);
   FName^.GetData(FileName);
   Dispose(FDialog, Done);
   if FileName <> '' then begin
      DeskTop^.GetExtent(R);
      Inc(WinCount);
      Editor := Application^.ValidView(New(PEditWindow, Init(R,FileName,WinCount)));
      Desktop^.Insert(Editor);
      if PEditWindow(Editor) = nil then
         MessageBox('Not enough memory. File too large', nil, mfError+mfOkButton);
   end
   else
      MessageBox('Filename not specified', nil, mfError+mfOkButton);
end;

constructor scrolltype.init( var r:trect; anumcols:integer; ahscrollbar, avscrollbar :pscrollbar; scrollertype : viewmodel );
begin
     tlistviewer.init(r, anumcols, nil, avscrollbar);
     scroller := scrollertype;
     scrolltype.setstate( sfselected OR sfactive OR sfvisible OR sfcursorvis, true );
     case scrollertype of
          assembly         : begin
                                topitem := 15;
                                scrolltype.setrange( topitem + 1 );
                             end;
          specialfunctregs : begin
                                topitem := 55;
                                scrolltype.setrange( topitem + 1 );
                             end;
          regs             : begin
                                topitem := 5;
                                scrolltype.setrange( topitem + 1 );
                             end;
          interndata       : begin
                                topitem := 127;
                                scrolltype.setrange( topitem + 1 );
                             end;
          externdata       : begin
                                topitem := 4095;
                                {real figure is 32k / 8, starts at zero }
                                scrolltype.setrange( topitem + 1 );
                             end;
          ports            : begin
                                topitem := 5;
                                scrolltype.setrange( topitem + 1 );
                             end;
     end;
     scrolltype.focusitem(0);
end;

function Scrolltype.gettext(item:integer; maxlen:integer) : string;
var st, CmdResult, Instr, PCAdr : string;
    loop, Instrptr : integer;
    baseadr : word;
begin
     st := '';
     baseadr := $8000;
     case scroller of
          assembly          : begin
                                 PCAdr := send('p ');
                                 if StrtoWord(PCAdr) < $8000 then
                                    PCAdr := '8000';
                                 CmdResult := send('d '+PCAdr+' 20');
                                 loop := 0;
                                 InstrPtr := 1;
                                 Instr := CmdResult[InstrPtr]+CmdResult[InstrPtr+1];
                                 while loop < item do
                                 begin
                                    InstrPtr := InstrPtr + (Instrs[StrtoInteger(Instr)].nbytes * 2 );
                                    Instr := CmdResult[InstrPtr]+CmdResult[InstrPtr+1];
                                    loop := loop + 1;
                                 end;
                                 PCAdr := WordtoString(StrtoWord(PCAdr)+((InstrPtr-1) DIV 2));
                                 st := PCAdr + '  '+DecodeInstruction( CmdResult, InstrPtr );
                              end;
          specialfunctregs  : begin
                                 st  := sfr[item].name + ' ';
                                 CmdResult := send( 's ' + sfr[item].addr );
                                 st  := st+strtobin(CmdResult)+ '  '+CmdResult;
                              end;
          regs              : begin
                                  st  := reg[item].name + ' ';
                                  case item of
                                      0, 1, 2: {acc, b, psw}
                                         begin
                                            CmdResult := send( 's ' + reg[item].addr );
                                            st := st+strtobin(CmdResult)+'  '+ CmdResult;
                                         end;
                                      3: begin  {sp}
                                            CmdResult := send( 's ' + reg[item].addr );
                                            st := st+'          '+ CmdResult;
                                         end;
                                      4: begin {pc}
                                            CmdResult := send( 'p ');
                                            st := st+'        '+ CmdResult;
                                         end;
                                      5: begin {dptr}
                                            CmdResult := send('s 83');
                                            CmdResult := CmdResult + send('s 82');
                                            st := st+'        '+ CmdResult;
                                         end;
                                  end;
                              end;
          interndata        : begin
                                  st  := integertostring( item );
                                  CmdResult := send( 'i ' + st );
                                  st  := st + '  ........  ' + CmdResult;
                              end;
          externdata        : begin
                                  st       := wordtostring( baseadr + (item * 8));
                                  CmdResult := send('d ' + wordtostring(baseadr+(item*8))+ ' 8');
                                  st := st + '  ' + CmdResult + '  ' + strtoascii(CmdResult);
                              end;
          ports            : begin
                                  st  := port552[item].name;
                                  CmdResult := send( 's ' + port552[item].addr );
                                  st  := st+strtobin(CmdResult)+'  '+ CmdResult;
                              end;
     end;
     gettext := st;
end;

function scrolltype.getpalette : PPalette;
const
{    cmytl = #6#6#7#7#6; { this leaves bar in all windows }
     cmytl = #6#6#7#6#6;  {this leaves bar only in active window}
     pmytl : string[length(cmytl)] = cmytl;
begin
     getpalette := @pmytl;
end;

procedure scrolltype.handleevent(var event : tevent );
var DDialog : PDialog;
    R    : Trect;
    PVal : PInputLine;
    DVal : String;
    CmdResult  : String;
    procedure getportvalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'Port Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, Port552[self.focused].Name+'New value',nil)));
           R.Assign(17,2,21,3);
           PVal := New(PInputLine, Init(R, 2));
           Insert(PVal);
        end;
        DVal := send('s '+Port552[Self.Focused].addr);
        DDialog^.SetData(DVal);
        if Self.Focused = 3 then begin
           write(char($07));
           MessageBox('Port 3 controls RD/WR',nil,mfError+mfOkButton)
        end
        else if Self.Focused = 5 then begin
           write(char($07));
           MessageBox('Port 5 is RD only',nil,mfError+mfOkButton)
        end
        else begin
           if Desktop^.ExecView(DDialog) <> cmCancel then begin
              DDialog^.GetData(DVal);
              if ValidHexStr(DVal) then
                 CmdResult := send('S '+Port552[self.focused].Addr + ' ' + DVal)
              else begin
                 write(char($07));
                 MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
              end;
              Message( pwin, evBroadcast, cmScrollBarChanged, nil );
              Message( sfrwin, evBroadcast, cmScrollBarChanged, nil );
           end;
        end;
        Dispose(DDialog, Done);
     end;
    procedure getidatavalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'IData Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, 'New value',nil)));
           R.Assign(17,2,21,3);
           PVal := New(PInputLine, Init(R, 2));
           Insert(PVal);
        end;
        DVal := send('i '+integertostring(Self.Focused));
        DDialog^.SetData(DVal);
        if Desktop^.ExecView(DDialog) <> cmCancel then begin
           DDialog^.GetData(DVal);
           if ValidHexStr(DVal) then
              CmdResult := send('I '+integertostring(self.focused) + ' ' + DVal)
            else begin
               write(char($07));
               MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
           end;
           Message( iwin, evBroadcast, cmScrollBarChanged, nil );
        end;
        Dispose(DDialog, Done);
     end;
    procedure getsfrvalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'SFR Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, 'New value',nil)));
           R.Assign(17,2,21,3);
           PVal := New(PInputLine, Init(R, 2));
           Insert(PVal);
        end;
        DVal := send('s '+sfr[Self.Focused].addr);
        DDialog^.SetData(DVal);
        if Sfr[Self.Focused].rdwr = false then begin
            write(char($07));
            MessageBox('Monitor will not alter Sfr register',nil,mfError+mfOKButton);
        end
        else begin
           if Desktop^.ExecView(DDialog) <> cmCancel then begin
              DDialog^.GetData(DVal);
              if ValidHexStr(DVal) then
                 CmdResult := send('S '+sfr[Self.Focused].addr + ' ' + DVal)
              else begin
                 write(char($07));
                 MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
              end;
              UpdateWindows;
           end;
        end;
        Dispose(DDialog, Done);
     end;
    procedure getregsvalue;
    begin
        R.Assign(30,8,55,15);
        DDialog := New(PDialog, Init(R, 'Register Value?' ));
        with DDialog^ do begin
           R.Assign(3,4,9,6);
           Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
           R.Assign(10,4,22,6);
           Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
           R.Assign(1,2,15,3);
           Insert(New(PLabel, Init(R, 'New value',nil)));
           Case Self.Focused of
             0, 1, 2, 3: begin
                           R.Assign(17,2,21,3);
                           PVal := New(PInputLine, Init(R, 2));
                         end;
             4, 5      : begin
                           R.Assign(17,2,23,3);
                           PVal := New(PInputLine, Init(R, 4));
                         end;
           end;
           Insert(PVal);
        end;
        Case Self.Focused of
            0, 1, 2, 3 : Dval := send( 's ' + reg[Self.Focused].addr );
                     4 : Dval := send( 'p ');
                     5:  begin {dptr}
                            Dval := send('s 83');
                            Dval := Dval + send('s 82');
                         end;
        end;
        DDialog^.SetData(DVal);
        if Desktop^.ExecView(DDialog) <> cmCancel then begin
           DDialog^.GetData(DVal);
           if ValidHexStr(DVal) then begin
              Case Self.Focused of
                  0, 1, 2, 3 : CmdResult := send( 'S ' + reg[Self.Focused].addr + ' ' + Dval);
                           4 : CmdResult := send( 'P '+Dval);
                           5:  begin {dptr}
                                  while length(Dval) < 4 do
                                     Dval := '0' + Dval;
                                  CmdResult := send('S 83 '+Dval[1]+Dval[2]);
                                  CmdResult := send('S 82 '+Dval[3]+Dval[4]);
                                end;
              end;
           end
           else begin
              write(char($07));
              MessageBox('Invalid number. Hexadecimal only',nil,mfError+mfOkButton);
           end;
           UpdateWindows;
        end;
        Dispose(DDialog, Done);
     end;

begin
    tlistviewer.handleevent(event);
    if event.what = evkeydown then
    begin
        case event.keycode of
          kbenter : begin
                       case scroller of
                          {assembly,specialfuncregs,regs,interndata}
                          {externdata,ports}
                          ports            : getportvalue;
                          interndata       : getidatavalue;
                          specialfunctregs : getsfrvalue;
                          regs             : getregsvalue;
                       end;
                       clearevent(event);
                     end;
        end;
    end
    else
       exit;
end;

constructor scrollwindow.init( var r : trect; wintitle : string;  winnum : word;
            scrollertype : viewmodel );
begin
     Twindow.init( r, wintitle, 0 );
     getcliprect( r );
     r.grow( -1, -1 );
     setstate(sfshadow, false);
     flags := 0;
     options := options or ofTileable;
     vscrollbar := standardscrollbar( sbvertical OR sbhandlekeyboard );
     interior := new( scrtype, Init( r, 1, nil, vscrollbar, scrollertype ) );
     insert( interior );
end;

procedure HandleRs232;
var         S : TextBuf;
    LineCount : Integer;
begin
   LineCount := 0;
   while OutPtr <> InPtr do
   begin
     LineCount := LineCount + 1;
     if RecBuffer[OutPtr] = CR then begin
        S[0] := char(LF);
        LineCount := 0;
     end
     else S[0] := char(RecBuffer[OutPtr]);
     Interior^.StrWrite(S, 1);
     OutPtr := OutPtr + 1;
     if OutPtr > BuffLimit then OutPtr := 1;
     if LineCount > 75 then begin    {don't exceed line length 128}
        LineCount := 0;
        S[0] := char(LF);
        Interior^.StrWrite(S,1);
     end;
   end;
end;

{ TTerminalWindow }
constructor TTerminalWindow.Init(Bounds: TRect; WinTitle: String;
  WindowNo: Word; var Interior: MyTerm; ABufSize: Word);
begin
  RunningTerminal := True;
  Save552State  := Running80C552;
  Running80C552 := false;
  TWindow.Init(Bounds, WinTitle, WindowNo);
  Interior := MakeInterior(Bounds, ABufSize);
  Insert(Interior);
end;

destructor TTerminalWindow.Done;
begin
  Interior^.EnableCommands(CommandSet);
  RunningTerminal := false;
  Running80C552 := Save552State;
  TWindow.Done;
end;

function TTerminalWindow.MakeInterior(Bounds: TRect;
  ABufSize: Word): MyTerm;
begin
  GetExtent(Bounds);
  Bounds.Grow(-1, -1);
  MakeInterior := New(MyTerm, Init(Bounds,
    StandardScrollBar(sbHorizontal + sbHandleKeyboard),
    StandardScrollBar(sbVertical + sbHandleKeyboard),
    ABufSize));
end;

procedure Terminal.HandleEvent(var Event:TEvent);
var S : TextBuf;
begin
  TTerminal.HandleEvent(Event);
  if event.what = evKeydown then
  begin
    if (event.Keycode AND $00ff) in [32..127] then
    begin
       if lecho = halfduplex then
       begin
          S[0] := Event.CharCode;
          Self.StrWrite(S, 1);
       end;
       putch(Byte(Event.CharCode));
       clearevent(event);
    end
    else if event.keycode = kbenter then
    begin
       if lecho = halfduplex then
       begin
          S[0] := char(LF);
          Self.StrWrite(S, 1);
       end;
       putch(CR);
       clearevent(event);
    end;
  end
  else
    exit;
end;

constructor mon.Init;
var  R       :TRect;
     H       :Word;
     Startup : PDialog;
     Control : Word;
begin
     H := PtrRec(HeapEnd).Seg - PtrRec(HeapPtr).Seg;
     if H > HeapSize then BufHeapSize := H - HeapSize else BufHeapSize := 0;
     InitBuffers;
     Ticks := 0;
     Running80C552 := True;
     RunningTerminal := false;
     acia[com1] := memw[$0040:0000];
     acia[com2] := memw[$0040:0002];
     Com1Inst := false;
     Com2Inst := false;
     lecho := halfduplex;
     Currentport := Com1;
     ComPortInfo[CurrentPort].Baud := b9600;
     ComPortInfo[CurrentPort].Data := eight;
     ComPortInfo[CurrentPort].Stop := one;
     ComPortInfo[CurrentPort].Parity  := noparity;
     ComPortInfo[CurrentPort].echo    := halfduplex;
     Initcomport( com1, b9600, eight, noparity, one );
     tapplication.init;
     RegisterObjects;
     RegisterViews;
     RegisterMenus;
     RegisterDialogs;
     RegisterApp;
     RegisterCalc;
     RegisterEditors;
     GetExtent(R);
     R.A.X := R.B.X - 9; R.B.Y := R.A.Y + 1;
     Clock := New(PClockView, Init(R));
     Insert(Clock);
     GetExtent(R);
     Dec(R.B.X);
     R.A.X := R.B.X - 9; R.A.Y := R.B.Y - 1;
     Heap := New(PHeapView, Init(R));
     Insert(Heap);
     getextent(r);
     R.Assign(20,10,60,20);
     Startup := New(PDialog, Init(R, '80C552 Monitor' ));
     Startup^.Options := Startup^.Options + ofcentered;
     with Startup^ do begin
         R.Assign(3,7,9,9);
         Insert(New(PButton, Init(R,'~O~k', cmOk, bfDefault)));
         R.Assign(10,7,22,9);
         Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
         SelectNext(False);
         R.Assign(1,2,30,3);
         Insert(New(PLabel, Init(R, 'Copyright B Brown, Dec 1991',nil)));
         R.Assign(1,5,30,6);
         Insert(New(Plabel, Init(R, '        Reset target CPU', nil)));
     end;
     write(char($07));
     control := Desktop^.ExecView(Startup);
     Dispose(Startup,Done);
     inc(wincount);
     rdat.assign( 0,0,22,8);
     rwin := new(scrwindow, init(rdat, 'Registers', wincount, regs ) );
     desktop^.insert(rwin);
     inc(wincount);
     sfrdat.assign( 0,8,22,22);
     sfrwin := new(scrwindow, init(sfrdat, 'Sfr registers ', wincount, specialfunctregs ) );
     desktop^.insert(sfrwin);
     inc(wincount);
     asmdat.assign( 22,0,60,10);
     asmwin := new(scrwindow, init(asmdat, 'Assembly', wincount, assembly ) );
     desktop^.insert(asmwin);
     inc(wincount);
     xdat.assign( 22,10,60,22);
     xwin := new(scrwindow, init(xdat, 'Code (xdata)', wincount, externdata ) );
     desktop^.insert(xwin);
     inc(wincount);
     pdat.assign( 60,0,80,8);
     pwin := new(scrwindow, init(pdat, 'Ports', wincount, ports ) );
     desktop^.insert(pwin);
     inc(wincount);
     idat.assign( 60,8,80,22);
     iwin := new(scrwindow, init(idat, 'Idata', wincount, interndata ) );
     desktop^.insert(iwin);
     rwin^.select;
end;

procedure mon.handleevent( var event : tevent );
   procedure QuitNow;
   begin
      write(char($07));
      if MessageBox('Exit Program? ', nil, mfWarning + mfOkCancel) = cmCancel then
         ClearEvent(Event);
   end;
   procedure Calculator;
   var P : PCalculator;
   begin
     P := New(PCalculator, Init);
     if ValidView(P) <> nil then
         DeskTop^.Insert(P);
   end;
begin
     if event.what = evcommand then
        if event.command = cmQuit then QuitNow;
     tapplication.handleevent( event );
     if event.what = evcommand then begin
          case event.command of
              cmDownload : Transfer(FILEDN);
              cmUpload   : Transfer(FILEUP);
              cmDos      : Begin Gotodos(''); ReDraw; End;
              cmCalc     : Calculator;
              cmRegisters: rwin^.select;
              cmXdata    : xwin^.select;
              cmIData    : iwin^.select;
              cmAssembly : asmwin^.select;
              cmSFR      : sfrwin^.select;
              cmPorts    : pwin^.select;
              cmGoPCAdr  : RunPCAtAddress;
              cmChDir    : ChangeDir;
              cmViewFile : OpenFile('*.*');
{              cmEdit     : begin  GotoDos('/c EDIT.BAT'); Redraw; End;
}
              cmEdit     : MonEditor;
              cmReset    : ResetPC;
              cmHaltPC   : HaltPC;
              cmRunPC    : RunPC;
              cmTracePC  : TracePC;
              cmTerminal : Termrs232;
              cmTermOpts : TermOpts;
              cmUpdate   : UpdateWindows;
          else
              {handle enter, up, down, left right}
              exit
          end;
          clearevent(event);
     end;
end;

procedure mon.initmenubar;
var r : trect;
begin
     getextent(r);
     r.b.y := r.a.y + 1;
     menubar := New( Pmenubar, Init(r, Newmenu(
             NewSubMenu('~F~ile  ', hcNocontext, NewMenu(
                 NewItem('~C~hange Dir     ','F2', kbF2, cmChDir, hcnocontext,
                 NewItem('~D~ownload to 552','F3', kbF3, cmdownload, hcNoContext,
                 NewItem('~S~hell to Dos   ','F4', kbF4, cmDos,    hcnocontext,
                 NewItem('~U~pload from 552','F5', kbF5, cmupload, hcnocontext,
                 NewItem('~V~iew file      ','F6', kbF6, cmViewFile, hcNoContext,
                 nil)))))),
             NewSubMenu('~M~isc  ', hcNoContext, NewMenu(
                 NewItem('~C~alculator  ','F7', kbF7, cmCalc, hcnocontext,
                 NewItem('e~D~itor      ','F8', kbf8, cmEdit, hcnocontext,
                 NewItem('t~E~rminal    ','ALT-E', kbALTE, cmTerminal, hcnocontext,
                 NewItem('Term ~O~ptions','ALT-O', kbALTO, cmTermOpts, hcnocontext,
                 nil))))),
             NewSubMenu('~5~52Processor ', hcNocontext, NewMenu(
                 NewItem('~G~o @Address ','ALT-G', kbALTG, cmGoPcAdr, hcnocontext,
                 NewItem('~H~alt PC     ','ALT-H', kbALTH, cmHaltPC,  hcnocontext,
                 NewItem('~R~eset Target','ALT-Z', kbALTZ, cmReset,   hcnocontext,
                 NewItem('R~u~n PC      ','ALT-U', kbALTU, cmRunPC,   hcnocontext,
                 NewItem('~T~race PC    ','ALT-T', kbALTT, cmTracePC, hcnocontext,
                 nil)))))),
             NewSubMenu('~W~indow  ', hcNoContext, NewMenu(
                 NewItem('~A~ssembly  ','ALT-A',kbALTA, cmassembly,  hcnocontext,
                 NewItem('~I~data     ','ALT-I',kbALTI, cmidata,     hcnocontext,
                 NewItem('~P~orts     ','ALT-P',kbALTP, cmPorts,     hcnocontext,
                 NewItem('~R~egisters ','ALT-R',kbALTR, cmregisters, hcnocontext,
                 NewItem('~S~FRs      ','ALT-S',kbALTS, cmsfr,       hcnocontext,
                 NewItem('~X~data     ','ALT-C',kbALTC, cmxdata,     hcnocontext,
                 NewItem('~N~ext      ', 'F9',  kbF9,   cmnext,      hcnocontext,
                 NewItem('~U~pdate windows','ALT-F1',kbALTF1,cmUpdate,hcnocontext,
                 nil))))))))),
             nil)))))))
end;

procedure mon.initstatusline;
var r : trect;
begin
     getextent(R);
     r.a.y := r.b.y - 1;
     statusline := New(PstatusLine, Init(R,
        NewStatusDef(0, $ffff,
           NewStatusKey('~F10~Menu', kbF10,   cmMenu,
           NewStatusKey('~AltX~Exit', kbAltX,  cmQuit,
           NewStatusKey('~AltF3~Close', kbAltF3, cmClose,
           NewStatusKey('~F4~Dos ', kbF4, cmDos,
           NewStatusKey('~F6~View', kbF6, cmViewFile,
           NewStatusKey('~F7~Calc', kbF7, cmCalc,
           NewStatusKey('~F8~Edit', kbF8, cmEdit,
           NewStatusKey('~F9~Next', kbF9, cmNext,
           nil)))))))),
        nil)
     ))
end;

procedure Mon.ViewFile(FileName : PathStr);
var  W:PWindow;
begin
    W := New(PFileWindow, Init(FileName));
    if ValidView(W) <> nil then
       DeskTop^.Insert(W);
    {the problem here is the deallocation of the PFileWindow}
    {it leaves 32 bytes unaccounted for!!!!                 }
end;

procedure Mon.OpenFile(WildCard:PathStr);
var  D:PFileDialog;
     FileName : PathStr;
begin
    D := New(PFileDialog, Init(WildCard, 'Open a File', '~N~ame',
         fdOpenButton, 100));
    if ValidView(D) <> nil then begin
       if Desktop^.ExecView(D) <> cmCancel then begin
          D^.GetFileName(FileName);
          ViewFile(FileName);
       end;
       Dispose(D, Done);
   end;
end;

procedure Mon.ChangeDir;
var  D:PChDirDialog;
begin
    D := New(PChDirDialog, Init(cdNormal, 101));
    if ValidView(D) <> nil then begin
       DeskTop^.ExecView(D);
       Dispose(D, Done);
    end;
end;

procedure Mon.OutOfMemory;
begin
     MessageBox('Not Enough memory for this operation.', nil, mfError + mfOkButton);
end;

procedure Mon.Idle;
begin
  TApplication.Idle;
  Clock^.Update;
  Heap^.Update;
  If Running80C552 then begin
     Ticks := Ticks + 1;
     If Ticks > $3000 then begin  { 3000hex = about seven to eight seconds}
       UpDateWindows;
       Ticks := 0;
     end;
  end;
  if RunningTerminal then HandleRs232;
end;

destructor mon.Done;
begin
     deinstallrs232(currentport);
     doneduffers;
     TApplication.Done;
end;

begin
     monitor.init;
     monitor.run;
     monitor.done;
end.
